/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "sg.y" /* yacc.c:339  */


/*
 * ufdbGuard is copyrighted (C) 2005-2020 by URLfilterDB B.V. with all rights reserved.
 *
 * Parts of the ufdbGuard daemon are based on squidGuard.
 * squidGuard is copyrighted (C) 1998 by
 * ElTele st AS, Oslo, Norway, with all rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (version 2) as
 * published by the Free Software Foundation.  It is distributed in the
 * hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
 * implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License (GPL) for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * (GPL2) along with this program.
 */

#define YYMALLOC  ufdbMalloc
#define YYFREE    ufdbFree

#define UFDB_LOG_USER_QUOTA   0   /* TODO remove */

#undef UFDB_DEBUG_ACL_ACCESS

#include "ufdb.h"
#include "sg.h"
#include "ufdblib.h"
#include "ufdbdb.h"
#include "ufdbchkport.h"

#define UFDB_DEBUG 0

#if UFDB_DEBUG
#undef YYDEBUG
#define YYDEBUG 1
#endif

#define UFDB_TIME_DEBUG 0

#include <pthread.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <grp.h>
#include <syslog.h>
#include <signal.h>
#include <sched.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/socket.h>


FILE * yyin;
FILE * yyout;
int    lineno;

extern struct ufdbSetting * lastSetting;
extern struct ufdbSetting * Setting;

extern struct Source * lastSource;

extern struct Category * lastCat;
extern struct Category * Cat;

extern struct sgRewrite * lastRewrite;
extern struct sgRewrite * Rewrite;
extern struct ufdbRegExp *  lastRewriteRegExec;

extern struct ufdbTime * lastTime;
extern struct ufdbTime * TimeList;

extern struct LogFileStat * lastLogFileStat;
extern struct LogFileStat * LogFileStat;

extern struct TimeElement * lastTimeElement;
extern struct TimeElement * TimeElement;

extern struct Acl * lastAcl;
extern struct Acl * defaultAcl;
extern struct Aclcategory * lastAclcategory;
 
extern struct ufdbRegExp * lastRegExpDest;

extern int    httpsConnectionCacheSize;

extern int    globalDebugTimeDelta;

static int   numTimeElements = 0;
static int * TimeElementsEvents = NULL;

static int   time_switch = 0;
static int   date_switch = 0;

static void setRefreshUserlist( int nmin );
static void setRefreshDomainlist( int nmin );
static void setRefreshIPlist( int nmin );
static void ufdbSourceGroup( int groupType, char * groupName );
static void ufdbSourceUserQuota( const char * seconds, const char * sporadic, const char * renew );
void sgAclSetValue( const char * what, const char * value, int allowed );
void sgIpv4( const char * name, int type, char * file, int lineno );
struct Ipv4 * sgIpv4Last( struct Source * s );
void sgIpv6( const char * addr, int type, char * file, int line );
void ufdbFreeDomainDb( struct sgDb * dbp );

static void   sgTime( char * );
static struct ufdbTime * sgTimeFindName( const char * name );
static void   sgTimeElementInit( void );
static void   sgTimeElementAdd( char *, char );
static void   sgTimeElementEnd( void );
static void   defSourceTime( char * name, int within );



#line 186 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ADMINISTRATOR = 258,
    QSTRING = 259,
    CHECK_PROXY_TUNNELS = 260,
    QUEUE_CHECKS = 261,
    AGGRESSIVE = 262,
    LOG_ONLY = 263,
    ON = 264,
    OFF = 265,
    CHAR_MINUS = 266,
    CHAR_I = 267,
    CHAR_EXCLAMATION = 268,
    IGNORECASE = 269,
    COMMA = 270,
    EQUAL = 271,
    PORT = 272,
    HTTP_SERVER = 273,
    INTERFACE = 274,
    IMAGES = 275,
    HTTPS_PROHIBIT_INSECURE_SSLV2 = 276,
    HTTPS_PROHIBIT_INSECURE_SSLV3 = 277,
    HTTPS_CONNECTION_CACHE_SIZE = 278,
    IDENTIFIER = 279,
    WORD = 280,
    END = 281,
    START_BRACKET = 282,
    STOP_BRACKET = 283,
    WEEKDAY = 284,
    CATEGORY = 285,
    REWRITE = 286,
    ACL = 287,
    CPUS = 288,
    TIME = 289,
    TVAL = 290,
    DVAL = 291,
    DVALCRON = 292,
    BLOCK_BUMPED_CONNECT = 293,
    EVALUATE_AND = 294,
    EVALUATE_OR = 295,
    SOURCE = 296,
    CONTINUE = 297,
    IPV4ADDR = 298,
    IPV4NET = 299,
    IPV4CLASS = 300,
    IPV4RANGE = 301,
    IPV6ADDR = 302,
    IPV6NET = 303,
    DBHOME = 304,
    DOMAINLIST = 305,
    EXECDOMAINLIST = 306,
    REFRESHDOMAINLIST = 307,
    URLLIST = 308,
    EXPRESSIONLIST = 309,
    CACERTS = 310,
    CACERTSDIR = 311,
    IPV4 = 312,
    IPV4LIST = 313,
    IPV6 = 314,
    IPV6LIST = 315,
    DOMAIN = 316,
    UNIX = 317,
    LDAP = 318,
    USER = 319,
    USERLIST = 320,
    EXECUSERLIST = 321,
    REFRESHUSERLIST = 322,
    EXECIPLIST = 323,
    REFRESHIPLIST = 324,
    USERQUOTA = 325,
    GROUP = 326,
    NL = 327,
    NUMBER = 328,
    NUMBERS = 329,
    PASS = 330,
    REDIRECT = 331,
    SUBST = 332,
    CHAR = 333,
    MINUTELY = 334,
    HOURLY = 335,
    DAILY = 336,
    WEEKLY = 337,
    DATE = 338,
    REDIRECT_FATAL_ERROR = 339,
    REDIRECT_LOADING_DATABASE = 340,
    REDIRECT_HTTPS = 341,
    REDIRECT_BUMPED_HTTPS = 342,
    WITHIN = 343,
    OUTSIDE = 344,
    ELSE = 345,
    ANONYMOUS = 346,
    SPORADIC = 347,
    PIDFILE = 348,
    LOGFILE = 349,
    LOGDIR = 350,
    LOGPASS = 351,
    LOGBLOCK = 352,
    LOGALL = 353,
    LOGALL_HTTPD = 354,
    MAIL_SERVER = 355,
    MY_HOSTNAME = 356,
    ADMIN_EMAIL = 357,
    SENDER_EMAIL = 358,
    EXTERNAL_STATUS_COMMAND = 359,
    TOKEN_ALLOW = 360,
    TOKEN_DENY = 361,
    YOUTUBE_EDUFILTER = 362,
    YOUTUBE_EDUFILTER_ID = 363,
    ALLOW_GOOGLE_HTTPS_USING_IP = 364,
    URL_LOOKUP_RESULT_DB_RELOAD = 365,
    URL_LOOKUP_RESULT_FATAL_ERROR = 366,
    URL_LOOKUP_DELAY_DB_RELOAD = 367,
    OPTION = 368,
    UFDB_SHOW_URL_DETAILS = 369,
    UFDB_LOG_URL_DETAILS = 370,
    SQUID_VERSION = 371,
    SQUID_USES_ACTIVE_BUMPING = 372,
    UPLOAD_CRASH_REPORTS = 373,
    LOOKUP_REVERSE_IP = 374,
    USE_IPV6_ON_WAN = 375,
    STRIP_DOMAIN_FROM_USERNAME = 376,
    UFDB_DEBUG_FILTER = 377,
    UFDB_DEBUG_COREDUMP = 378,
    UFDB_DEBUG_SKYPE_PROBES = 379,
    UFDB_DEBUG_GTALK_PROBES = 380,
    UFDB_DEBUG_YAHOOMSG_PROBES = 381,
    UFDB_DEBUG_AIM_PROBES = 382,
    UFDB_DEBUG_FBCHAT_PROBES = 383,
    UFDB_DEBUG_CITRIXONLINE_PROBES = 384,
    UFDB_EXPRESSION_OPTIMISATION = 385,
    UFDB_EXPRESSION_DEBUG = 386,
    UFDB_DEBUG_EXTERNAL_SCRIPTS = 387,
    UFDB_NUM_WORKER_THREADS = 388,
    ENFORCE_HTTPS_WITH_HOSTNAME = 389,
    ENFORCE_HTTPS_OFFICAL_CERTIFICATE = 390,
    ALLOW_SKYPE_OVER_HTTPS = 391,
    ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS = 392,
    ALLOW_GTALK_OVER_HTTPS = 393,
    ALLOW_YAHOOMSG_OVER_HTTPS = 394,
    ALLOW_AIM_OVER_HTTPS = 395,
    ALLOW_FBCHAT_OVER_HTTPS = 396,
    ALLOW_CITRIXONLINE_OVER_HTTPS = 397,
    ALLOW_ANYDESK_OVER_HTTPS = 398,
    ALLOW_TEAMVIEWER_OVER_HTTPS = 399,
    ANALYSE_UNCATEGORISED = 400,
    LOG_UNCATEGORISED_URLS = 401,
    UPLOAD_STATS = 402,
    SAFE_SEARCH = 403,
    MAX_LOGFILE_SIZE = 404
  };
#endif
/* Tokens.  */
#define ADMINISTRATOR 258
#define QSTRING 259
#define CHECK_PROXY_TUNNELS 260
#define QUEUE_CHECKS 261
#define AGGRESSIVE 262
#define LOG_ONLY 263
#define ON 264
#define OFF 265
#define CHAR_MINUS 266
#define CHAR_I 267
#define CHAR_EXCLAMATION 268
#define IGNORECASE 269
#define COMMA 270
#define EQUAL 271
#define PORT 272
#define HTTP_SERVER 273
#define INTERFACE 274
#define IMAGES 275
#define HTTPS_PROHIBIT_INSECURE_SSLV2 276
#define HTTPS_PROHIBIT_INSECURE_SSLV3 277
#define HTTPS_CONNECTION_CACHE_SIZE 278
#define IDENTIFIER 279
#define WORD 280
#define END 281
#define START_BRACKET 282
#define STOP_BRACKET 283
#define WEEKDAY 284
#define CATEGORY 285
#define REWRITE 286
#define ACL 287
#define CPUS 288
#define TIME 289
#define TVAL 290
#define DVAL 291
#define DVALCRON 292
#define BLOCK_BUMPED_CONNECT 293
#define EVALUATE_AND 294
#define EVALUATE_OR 295
#define SOURCE 296
#define CONTINUE 297
#define IPV4ADDR 298
#define IPV4NET 299
#define IPV4CLASS 300
#define IPV4RANGE 301
#define IPV6ADDR 302
#define IPV6NET 303
#define DBHOME 304
#define DOMAINLIST 305
#define EXECDOMAINLIST 306
#define REFRESHDOMAINLIST 307
#define URLLIST 308
#define EXPRESSIONLIST 309
#define CACERTS 310
#define CACERTSDIR 311
#define IPV4 312
#define IPV4LIST 313
#define IPV6 314
#define IPV6LIST 315
#define DOMAIN 316
#define UNIX 317
#define LDAP 318
#define USER 319
#define USERLIST 320
#define EXECUSERLIST 321
#define REFRESHUSERLIST 322
#define EXECIPLIST 323
#define REFRESHIPLIST 324
#define USERQUOTA 325
#define GROUP 326
#define NL 327
#define NUMBER 328
#define NUMBERS 329
#define PASS 330
#define REDIRECT 331
#define SUBST 332
#define CHAR 333
#define MINUTELY 334
#define HOURLY 335
#define DAILY 336
#define WEEKLY 337
#define DATE 338
#define REDIRECT_FATAL_ERROR 339
#define REDIRECT_LOADING_DATABASE 340
#define REDIRECT_HTTPS 341
#define REDIRECT_BUMPED_HTTPS 342
#define WITHIN 343
#define OUTSIDE 344
#define ELSE 345
#define ANONYMOUS 346
#define SPORADIC 347
#define PIDFILE 348
#define LOGFILE 349
#define LOGDIR 350
#define LOGPASS 351
#define LOGBLOCK 352
#define LOGALL 353
#define LOGALL_HTTPD 354
#define MAIL_SERVER 355
#define MY_HOSTNAME 356
#define ADMIN_EMAIL 357
#define SENDER_EMAIL 358
#define EXTERNAL_STATUS_COMMAND 359
#define TOKEN_ALLOW 360
#define TOKEN_DENY 361
#define YOUTUBE_EDUFILTER 362
#define YOUTUBE_EDUFILTER_ID 363
#define ALLOW_GOOGLE_HTTPS_USING_IP 364
#define URL_LOOKUP_RESULT_DB_RELOAD 365
#define URL_LOOKUP_RESULT_FATAL_ERROR 366
#define URL_LOOKUP_DELAY_DB_RELOAD 367
#define OPTION 368
#define UFDB_SHOW_URL_DETAILS 369
#define UFDB_LOG_URL_DETAILS 370
#define SQUID_VERSION 371
#define SQUID_USES_ACTIVE_BUMPING 372
#define UPLOAD_CRASH_REPORTS 373
#define LOOKUP_REVERSE_IP 374
#define USE_IPV6_ON_WAN 375
#define STRIP_DOMAIN_FROM_USERNAME 376
#define UFDB_DEBUG_FILTER 377
#define UFDB_DEBUG_COREDUMP 378
#define UFDB_DEBUG_SKYPE_PROBES 379
#define UFDB_DEBUG_GTALK_PROBES 380
#define UFDB_DEBUG_YAHOOMSG_PROBES 381
#define UFDB_DEBUG_AIM_PROBES 382
#define UFDB_DEBUG_FBCHAT_PROBES 383
#define UFDB_DEBUG_CITRIXONLINE_PROBES 384
#define UFDB_EXPRESSION_OPTIMISATION 385
#define UFDB_EXPRESSION_DEBUG 386
#define UFDB_DEBUG_EXTERNAL_SCRIPTS 387
#define UFDB_NUM_WORKER_THREADS 388
#define ENFORCE_HTTPS_WITH_HOSTNAME 389
#define ENFORCE_HTTPS_OFFICAL_CERTIFICATE 390
#define ALLOW_SKYPE_OVER_HTTPS 391
#define ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS 392
#define ALLOW_GTALK_OVER_HTTPS 393
#define ALLOW_YAHOOMSG_OVER_HTTPS 394
#define ALLOW_AIM_OVER_HTTPS 395
#define ALLOW_FBCHAT_OVER_HTTPS 396
#define ALLOW_CITRIXONLINE_OVER_HTTPS 397
#define ALLOW_ANYDESK_OVER_HTTPS 398
#define ALLOW_TEAMVIEWER_OVER_HTTPS 399
#define ANALYSE_UNCATEGORISED 400
#define LOG_UNCATEGORISED_URLS 401
#define UPLOAD_STATS 402
#define SAFE_SEARCH 403
#define MAX_LOGFILE_SIZE 404

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 121 "sg.y" /* yacc.c:355  */

  char * string;
  char * tval;
  char * dval;
  char * dvalcron;
  int    integer;

#line 532 "y.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 549 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   563

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  150
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  115
/* YYNRULES -- Number of rules.  */
#define YYNRULES  338
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  499

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   404

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   210,   210,   214,   215,   219,   224,   225,   229,   230,
     231,   235,   239,   243,   247,   251,   255,   259,   263,   264,
     269,   273,   279,   285,   291,   298,   299,   300,   301,   305,
     309,   313,   314,   318,   323,   328,   333,   337,   341,   345,
     350,   373,   378,   383,   388,   393,   397,   401,   405,   409,
     413,   417,   421,   425,   429,   433,   437,   441,   445,   449,
     453,   457,   458,   462,   463,   467,   471,   482,   486,   487,
     491,   496,   501,   506,   511,   516,   523,   528,   536,   543,
     548,   560,   561,   567,   573,   574,   575,   579,   580,   584,
     588,   589,   591,   593,   595,   600,   604,   605,   609,   610,
     611,   612,   613,   614,   615,   616,   617,   618,   619,   620,
     621,   622,   623,   624,   625,   626,   627,   628,   629,   630,
     631,   632,   633,   634,   635,   636,   637,   638,   639,   640,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   652,   654,   656,   658,   663,   667,   670,   672,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     687,   688,   689,   691,   693,   695,   697,   698,   699,   700,
     701,   702,   703,   704,   705,   706,   707,   710,   713,   716,
     719,   723,   725,   726,   727,   730,   732,   733,   734,   738,
     741,   742,   746,   747,   748,   752,   754,   753,   758,   760,
     764,   770,   771,   772,   773,   774,   776,   778,   780,   784,
     786,   787,   788,   789,   790,   793,   795,   796,   800,   802,
     804,   806,   810,   812,   813,   817,   819,   824,   825,   829,
     832,   834,   839,   840,   841,   842,   845,   848,   851,   858,
     862,   865,   867,   872,   872,   872,   873,   873,   873,   874,
     874,   874,   875,   875,   876,   880,   880,   881,   885,   886,
     887,   888,   889,   890,   893,   896,   899,   903,   906,   907,
     911,   912,   913,   914,   915,   916,   917,   918,   919,   920,
     921,   922,   923,   924,   925,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   936,   937,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ADMINISTRATOR", "QSTRING",
  "CHECK_PROXY_TUNNELS", "QUEUE_CHECKS", "AGGRESSIVE", "LOG_ONLY", "ON",
  "OFF", "CHAR_MINUS", "CHAR_I", "CHAR_EXCLAMATION", "IGNORECASE", "COMMA",
  "EQUAL", "PORT", "HTTP_SERVER", "INTERFACE", "IMAGES",
  "HTTPS_PROHIBIT_INSECURE_SSLV2", "HTTPS_PROHIBIT_INSECURE_SSLV3",
  "HTTPS_CONNECTION_CACHE_SIZE", "IDENTIFIER", "WORD", "END",
  "START_BRACKET", "STOP_BRACKET", "WEEKDAY", "CATEGORY", "REWRITE", "ACL",
  "CPUS", "TIME", "TVAL", "DVAL", "DVALCRON", "BLOCK_BUMPED_CONNECT",
  "EVALUATE_AND", "EVALUATE_OR", "SOURCE", "CONTINUE", "IPV4ADDR",
  "IPV4NET", "IPV4CLASS", "IPV4RANGE", "IPV6ADDR", "IPV6NET", "DBHOME",
  "DOMAINLIST", "EXECDOMAINLIST", "REFRESHDOMAINLIST", "URLLIST",
  "EXPRESSIONLIST", "CACERTS", "CACERTSDIR", "IPV4", "IPV4LIST", "IPV6",
  "IPV6LIST", "DOMAIN", "UNIX", "LDAP", "USER", "USERLIST", "EXECUSERLIST",
  "REFRESHUSERLIST", "EXECIPLIST", "REFRESHIPLIST", "USERQUOTA", "GROUP",
  "NL", "NUMBER", "NUMBERS", "PASS", "REDIRECT", "SUBST", "CHAR",
  "MINUTELY", "HOURLY", "DAILY", "WEEKLY", "DATE", "REDIRECT_FATAL_ERROR",
  "REDIRECT_LOADING_DATABASE", "REDIRECT_HTTPS", "REDIRECT_BUMPED_HTTPS",
  "WITHIN", "OUTSIDE", "ELSE", "ANONYMOUS", "SPORADIC", "PIDFILE",
  "LOGFILE", "LOGDIR", "LOGPASS", "LOGBLOCK", "LOGALL", "LOGALL_HTTPD",
  "MAIL_SERVER", "MY_HOSTNAME", "ADMIN_EMAIL", "SENDER_EMAIL",
  "EXTERNAL_STATUS_COMMAND", "TOKEN_ALLOW", "TOKEN_DENY",
  "YOUTUBE_EDUFILTER", "YOUTUBE_EDUFILTER_ID",
  "ALLOW_GOOGLE_HTTPS_USING_IP", "URL_LOOKUP_RESULT_DB_RELOAD",
  "URL_LOOKUP_RESULT_FATAL_ERROR", "URL_LOOKUP_DELAY_DB_RELOAD", "OPTION",
  "UFDB_SHOW_URL_DETAILS", "UFDB_LOG_URL_DETAILS", "SQUID_VERSION",
  "SQUID_USES_ACTIVE_BUMPING", "UPLOAD_CRASH_REPORTS", "LOOKUP_REVERSE_IP",
  "USE_IPV6_ON_WAN", "STRIP_DOMAIN_FROM_USERNAME", "UFDB_DEBUG_FILTER",
  "UFDB_DEBUG_COREDUMP", "UFDB_DEBUG_SKYPE_PROBES",
  "UFDB_DEBUG_GTALK_PROBES", "UFDB_DEBUG_YAHOOMSG_PROBES",
  "UFDB_DEBUG_AIM_PROBES", "UFDB_DEBUG_FBCHAT_PROBES",
  "UFDB_DEBUG_CITRIXONLINE_PROBES", "UFDB_EXPRESSION_OPTIMISATION",
  "UFDB_EXPRESSION_DEBUG", "UFDB_DEBUG_EXTERNAL_SCRIPTS",
  "UFDB_NUM_WORKER_THREADS", "ENFORCE_HTTPS_WITH_HOSTNAME",
  "ENFORCE_HTTPS_OFFICAL_CERTIFICATE", "ALLOW_SKYPE_OVER_HTTPS",
  "ALLOW_UNKNOWN_PROTOCOL_OVER_HTTPS", "ALLOW_GTALK_OVER_HTTPS",
  "ALLOW_YAHOOMSG_OVER_HTTPS", "ALLOW_AIM_OVER_HTTPS",
  "ALLOW_FBCHAT_OVER_HTTPS", "ALLOW_CITRIXONLINE_OVER_HTTPS",
  "ALLOW_ANYDESK_OVER_HTTPS", "ALLOW_TEAMVIEWER_OVER_HTTPS",
  "ANALYSE_UNCATEGORISED", "LOG_UNCATEGORISED_URLS", "UPLOAD_STATS",
  "SAFE_SEARCH", "MAX_LOGFILE_SIZE", "$accept", "start", "qidentifier",
  "https_cache_size", "allow_or_deny", "on_or_off", "log_pass",
  "log_block", "log_all", "logall_httpd", "youtube_edufilter",
  "youtube_edufilter_id", "allow_google_https_using_ip", "debug_filter",
  "debug_coredump", "enforce_https_with_hostname",
  "enforce_https_offical_certificate", "https_prohibit_insecure_sslv2",
  "https_prohibit_insecure_sslv3", "check_proxy_tunnel_option",
  "check_proxy_tunnels", "admin_spec", "dbhome", "refreshuserlist",
  "refreshiplist", "refreshdomainlist", "url_lookup_result_db_reload",
  "url_lookup_result_fatal_error", "url_lookup_delay_db_reload",
  "squid_version", "num_worker_threads", "upload_crash_reports",
  "lookup_reverse_ip", "use_ipv6_on_wan", "squid_uses_active_bumping",
  "ufdb_log_url_details", "ufdb_show_url_details",
  "ufdb_debug_skype_probes", "ufdb_debug_gtalk_probes",
  "ufdb_debug_yahoomsg_probes", "ufdb_debug_aim_probes",
  "ufdb_debug_fbchat_probes", "ufdb_debug_citrixonline_probes",
  "ufdb_expression_optimisation", "ufdb_expression_debug",
  "ufdb_debug_external_scripts", "mail_server", "my_hostname",
  "admin_email", "sender_email", "external_status_command", "logdir",
  "pidfile", "port", "interface", "cpus", "upload_stats", "redirect_https",
  "redirect_bumped_https", "redirect_loading_database",
  "redirect_fatal_error", "log_uncategorised_urls",
  "analyse_uncategorised", "strip_domain_from_username", "safe_search",
  "max_logfile_size", "httpd_option", "httpd_options", "http_server_def",
  "category", "category_block", "category_contents", "category_content",
  "source", "source_block", "source_contents", "source_content", "domain",
  "user", "acl_block", "acl_contents", "acl_header", "acl_content", "$@1",
  "access_contents", "access_content", "access_pass", "ipv4s", "ipv4",
  "ipv6s", "ipv6", "rew", "rew_block", "rew_contents", "rew_content",
  "time", "time_block", "time_contents", "time_content", "$@2", "$@3",
  "$@4", "$@5", "$@6", "$@7", "$@8", "ttime", "$@9", "date", "dval",
  "tval", "dvalcron", "an_error", "statements", "statement", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404
};
# endif

#define YYPACT_NINF -345

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-345)))

#define YYTABLE_NINF -256

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -345,    16,    63,  -345,  -345,    -2,   340,   -62,     5,    68,
     145,   145,   -44,    11,    95,     7,   220,    -3,    -3,   263,
      -6,    -4,    10,  -345,    99,   110,   114,   117,   265,   267,
     145,   145,   145,   145,   124,   127,   136,   141,   197,   145,
     201,   145,   154,   154,   145,   145,   145,   203,   145,   145,
     145,   145,   145,    64,   145,   145,   145,   145,   145,   145,
     145,   145,   145,   145,   130,   145,   145,    78,   145,   145,
     145,   140,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,   189,  -345,   193,  -345,  -345,   195,  -345,
     205,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,   289,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,   120,   210,   222,
     290,   321,     2,   402,   469,    50,    70,   172,    98,   293,
     289,  -345,  -345,    12,  -345,  -345,  -345,   295,     3,    -3,
     219,   217,   298,   300,   303,    -3,    -3,    52,   260,  -345,
    -345,  -345,  -345,  -345,  -345,   348,  -345,   351,  -345,   199,
    -345,   354,    -3,    -3,   248,   361,    -3,    -3,    66,  -345,
    -345,  -345,    -3,    -3,    85,  -345,  -345,  -345,   -12,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,    -3,
      -3,   171,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,   401,   403,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,   413,  -345,   145,   145,   145,
     145,   145,   360,   411,   145,   145,   145,   145,   145,   145,
     145,   145,   145,   145,   191,  -345,  -345,    60,  -345,  -345,
     200,  -345,   419,   446,   271,  -345,  -345,  -345,  -345,   283,
    -345,  -345,  -345,  -345,  -345,   455,  -345,  -345,  -345,  -345,
     459,  -345,   328,    -3,   334,   132,   333,   335,   273,   464,
    -345,   468,   109,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,   473,  -345,  -345,
    -345,  -345,  -345,   268,  -345,  -345,  -345,  -345,  -345,  -345,
     271,  -345,  -345,  -345,  -345,  -345,  -345,  -345,   230,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,    94,
     329,  -345,  -345,  -345,  -345,  -345,   497,  -345,  -345,  -345,
     470,  -345,  -345,  -345,  -345,  -345,  -345,  -345,   329,   329,
     329,   332,  -345,   346,   373,   346,   363,  -345,   385,  -345,
    -345,  -345,  -345,   346,   346,   346,   329,   329,   329,  -345,
    -345,  -345,   346,   376,  -345,   186,   329,  -345,  -345
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     268,     0,     0,     1,   267,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   337,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   275,   277,   278,   279,   280,   330,   332,   331,
     281,   282,   283,   284,   285,   286,   276,   274,   287,   314,
     315,   316,   296,   297,   295,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   317,   290,   291,   292,   293,   294,   288,   289,   319,
     318,   320,   321,   322,   323,   324,   325,   327,   326,   329,
     328,   333,   273,   270,   272,     0,   271,   334,     0,   335,
       0,   336,   338,   269,    30,    26,    27,    28,    25,    29,
      65,     0,     4,     3,    67,    66,    10,     8,     9,    23,
      24,     5,    94,    91,    92,    93,    90,   228,   227,   190,
      68,    69,   239,   145,    32,    31,    35,    33,    34,    74,
      73,    71,    72,    64,    63,    62,    61,    11,    12,    13,
      14,    56,    57,    58,    59,    60,    15,    16,    17,     6,
       7,    36,    37,    38,    46,    45,    39,    44,    41,    42,
      43,    78,    19,    18,    20,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    40,    21,    22,    77,    76,    75,
      70,    79,    80,    96,   147,   230,   241,     0,     0,     0,
      88,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    89,   189,     0,   198,   191,    95,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    97,
     146,   172,   173,   180,   215,     0,   222,     0,   181,     0,
     185,     0,     0,     0,     0,     0,     0,     0,     0,   148,
     229,   232,     0,     0,     0,   231,   254,   240,   246,   252,
     242,    81,    83,    84,    82,    86,    85,    87,   192,     0,
       0,     0,   119,   118,   100,    99,    98,   101,   104,   103,
     102,   107,     0,     0,   106,   105,   113,   112,   115,   114,
     117,   116,   120,   121,   144,     0,   143,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   166,   168,   167,   169,   171,   170,
     149,   185,     0,     0,   150,   153,   152,   156,   157,     0,
     159,   158,   174,   175,   179,     0,   178,   233,   234,   238,
       0,   237,     0,     0,     0,     0,     0,     0,   195,     0,
     209,     0,     0,   199,   109,   108,   111,   110,   142,   141,
     130,   131,   122,   125,   123,   127,   129,   132,   140,   133,
     134,   135,   136,   137,   138,   139,   124,     0,   218,   221,
     220,   219,   216,     0,   225,   226,   223,   184,   183,   182,
     151,   155,   154,   161,   160,   188,   187,   186,     0,   177,
     176,   236,   235,   244,   247,   250,   264,   266,   253,   259,
     263,   193,   194,   196,   202,   201,   200,   204,   203,   208,
       0,   207,   217,   224,   165,   162,   163,   164,     0,     0,
       0,     0,   265,   258,     0,   262,     0,   210,     0,   214,
     211,   206,   205,   245,   248,   251,   261,     0,     0,   198,
     212,   213,   260,     0,   257,     0,     0,   197,   256
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -345,  -345,    -9,  -345,   350,    -8,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,   156,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,    57,  -345,
    -345,  -345,  -345,  -345,   -70,  -345,  -345,  -345,    14,  -345,
      -1,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -344,  -345,  -345,   -47,
    -269,  -345,  -345,  -345,  -345
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,   437,    72,   201,   159,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,   149,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   240,   241,   132,   133,
     134,   243,   269,   135,   136,   244,   289,   360,   364,   137,
     242,   254,   255,   476,   311,   393,   456,   354,   422,   357,
     426,   138,   139,   245,   295,   140,   141,   246,   300,   382,
     468,   383,   469,   384,   470,   385,   473,   487,   448,   449,
     474,   450,   142,     2,   143
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     155,   152,   144,   160,   166,   168,   152,   152,   172,   173,
     175,   150,   162,  -249,   314,   152,     3,  -243,   163,   184,
     186,   153,   187,   188,   189,   190,   153,   153,   315,   161,
     252,   196,   151,   198,   169,   153,   203,   204,   205,   308,
     207,   208,   209,   210,   211,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   152,   225,   226,   228,
     229,   230,   231,    -2,     4,   156,     5,   176,     6,   177,
     152,   296,   152,   157,   158,   423,   153,   334,   290,   156,
       7,     8,     9,   178,    10,    11,    12,   157,   158,   152,
     153,   374,   153,    13,    14,    15,    16,    17,   297,   152,
     309,   310,   152,   179,    18,   471,   475,   424,   425,   153,
     379,   154,    19,   152,   180,    20,   164,   165,   181,   153,
     167,   182,   153,   302,   483,   484,   485,   291,   191,   472,
      21,   192,    22,   153,   459,    23,   247,   212,   292,   293,
     193,   303,   492,   335,   294,   194,   156,    24,    25,    26,
      27,   227,   298,   299,   157,   158,    28,   375,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,   446,   447,
      39,    40,    41,    42,    43,    44,   380,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,   388,
     460,   195,   389,   224,   152,   197,   417,   206,    67,    68,
      69,    70,    71,   232,   497,   427,   233,   389,   493,   494,
     234,   152,   235,   152,   153,   428,   248,   498,   321,   322,
     318,   323,   236,   253,   418,   419,   420,   421,   249,   304,
     306,   153,   324,   153,   319,   301,   390,   391,   313,   316,
     317,   320,   325,   327,   329,   331,   332,   333,   336,   199,
     200,   390,   391,   361,   362,   392,   356,   152,   359,   152,
     363,   152,   366,   367,   368,   152,   371,   372,   373,   376,
     392,   337,   338,   377,   378,   381,   435,   153,   174,   153,
     183,   153,   185,   170,   171,   153,   436,   152,   339,   152,
     386,   387,   152,   464,   152,   250,   237,   152,   238,   239,
     465,   466,   467,   395,   397,   424,   425,   153,   305,   153,
     312,   369,   153,   326,   153,   328,   399,   153,   330,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,   415,   416,   145,   146,   147,   251,
     148,   429,   152,   432,   434,   152,   438,   443,   152,   445,
     451,   156,   452,   453,   472,   152,   440,   340,   446,   157,
     158,   442,   153,   355,   444,   153,   358,   341,   153,   365,
     455,  -255,   458,   461,   488,   153,   370,   496,  -126,   152,
     489,  -126,   490,   202,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   152,   307,   152,   353,   153,
    -126,  -126,   156,  -126,  -126,  -126,  -126,   152,   430,   495,
     157,   158,   463,   152,   486,   153,   394,   153,   396,     0,
     256,   462,     0,   257,     0,     0,  -126,   153,   398,  -128,
       0,     0,  -128,   153,   431,     0,     0,   480,  -126,  -126,
     152,   482,   258,   259,  -126,   260,   261,   262,   263,   152,
       0,  -128,  -128,   152,  -128,  -128,  -128,  -128,   152,   491,
     153,   433,   152,  -126,   152,     0,     0,     0,   264,   153,
     439,     0,     0,   153,   441,     0,     0,  -128,   153,   454,
     265,   266,   153,   457,   153,   481,   267,   270,     0,  -128,
    -128,   152,     0,     0,   477,  -128,     0,     0,   271,   272,
     478,   273,   479,     0,     0,   268,   418,   419,   420,   421,
       0,   153,     0,     0,  -128,     0,   274,   275,   276,   277,
     278,   279,     0,   280,   281,   282,     0,   283,     0,   284,
     285,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   286,   287,     0,
       0,     0,     0,   288
};

static const yytype_int16 yycheck[] =
{
       9,     4,     4,    11,    13,    14,     4,     4,    17,    18,
      19,    73,     1,    25,    11,     4,     0,    29,     7,    28,
      29,    24,    30,    31,    32,    33,    24,    24,    25,    73,
      28,    39,    27,    41,    27,    24,    44,    45,    46,    27,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,     4,    65,    66,    67,
      68,    69,    70,     0,     1,     1,     3,    73,     5,    73,
       4,     1,     4,     9,    10,    15,    24,    25,    28,     1,
      17,    18,    19,    73,    21,    22,    23,     9,    10,     4,
      24,    25,    24,    30,    31,    32,    33,    34,    28,     4,
      88,    89,     4,     4,    41,    11,   450,    47,    48,    24,
      25,    43,    49,     4,     4,    52,   105,   106,     4,    24,
      25,     4,    24,    25,   468,   469,   470,    77,     4,    35,
      67,     4,    69,    24,    25,    72,    16,    73,    88,    89,
       4,    43,   486,    91,    94,     4,     1,    84,    85,    86,
      87,    73,    82,    83,     9,    10,    93,    91,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,    36,    37,
     107,   108,   109,   110,   111,   112,    91,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,    28,
      91,     4,    31,    73,     4,     4,    15,     4,   145,   146,
     147,   148,   149,    73,    28,    15,    27,    31,   487,   488,
      27,     4,    27,     4,    24,    25,    16,   496,    11,    12,
      11,    14,    27,   242,    43,    44,    45,    46,    16,   248,
     249,    24,    25,    24,    25,    73,    75,    76,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   105,
     106,    75,    76,    64,    65,    94,   275,     4,   277,     4,
      71,     4,   281,   282,   283,     4,   285,   286,   287,   288,
      94,    21,    22,   292,   293,   294,    15,    24,    25,    24,
      25,    24,    25,    73,    74,    24,    25,     4,    38,     4,
     309,   310,     4,    73,     4,    15,    17,     4,    19,    20,
      80,    81,    82,   322,   323,    47,    48,    24,    25,    24,
      25,    73,    24,    25,    24,    25,   335,    24,    25,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,     6,     7,     8,    28,
      10,   360,     4,   362,   363,     4,    73,    29,     4,    25,
      27,     1,    27,    90,    35,     4,   375,   107,    36,     9,
      10,   380,    24,    25,   383,    24,    25,   117,    24,    25,
     389,    35,   391,   392,    11,    24,    25,    11,    28,     4,
      27,    31,     7,    43,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,     4,   250,     4,   148,    24,
      50,    51,     1,    53,    54,    55,    56,     4,   361,   489,
       9,    10,   423,     4,   471,    24,    25,    24,    25,    -1,
      28,   417,    -1,    31,    -1,    -1,    76,    24,    25,    28,
      -1,    -1,    31,    24,    25,    -1,    -1,   456,    88,    89,
       4,   460,    50,    51,    94,    53,    54,    55,    56,     4,
      -1,    50,    51,     4,    53,    54,    55,    56,     4,   478,
      24,    25,     4,   113,     4,    -1,    -1,    -1,    76,    24,
      25,    -1,    -1,    24,    25,    -1,    -1,    76,    24,    25,
      88,    89,    24,    25,    24,    25,    94,    28,    -1,    88,
      89,     4,    -1,    -1,     7,    94,    -1,    -1,    39,    40,
      13,    42,    15,    -1,    -1,   113,    43,    44,    45,    46,
      -1,    24,    -1,    -1,   113,    -1,    57,    58,    59,    60,
      61,    62,    -1,    64,    65,    66,    -1,    68,    -1,    70,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    -1,
      -1,    -1,    -1,    94
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   151,   263,     0,     1,     3,     5,    17,    18,    19,
      21,    22,    23,    30,    31,    32,    33,    34,    41,    49,
      52,    67,    69,    72,    84,    85,    86,    87,    93,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   107,
     108,   109,   110,   111,   112,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   145,   146,   147,
     148,   149,   153,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   218,   219,   220,   223,   224,   229,   241,   242,
     245,   246,   262,   264,     4,     6,     7,     8,    10,   169,
      73,    27,     4,    24,    43,   152,     1,     9,    10,   155,
     155,    73,     1,     7,   105,   106,   152,    25,   152,    27,
      73,    74,   152,   152,    25,   152,    73,    73,    73,     4,
       4,     4,     4,    25,   152,    25,   152,   155,   155,   155,
     155,     4,     4,     4,     4,     4,   155,     4,   155,   105,
     106,   154,   154,   155,   155,   155,     4,   155,   155,   155,
     155,   155,    73,   155,   155,   155,   155,   155,   155,   155,
     155,   155,   155,   155,    73,   155,   155,    73,   155,   155,
     155,   155,    73,    27,    27,    27,    27,    17,    19,    20,
     216,   217,   230,   221,   225,   243,   247,    16,    16,    16,
      15,    28,    28,   152,   231,   232,    28,    31,    50,    51,
      53,    54,    55,    56,    76,    88,    89,    94,   113,   222,
      28,    39,    40,    42,    57,    58,    59,    60,    61,    62,
      64,    65,    66,    68,    70,    71,    88,    89,    94,   226,
      28,    77,    88,    89,    94,   244,     1,    28,    82,    83,
     248,    73,    25,    43,   152,    25,   152,   217,    27,    88,
      89,   234,    25,   152,    11,    25,   152,   152,    11,    25,
     152,    11,    12,    14,    25,   152,    25,   152,    25,   152,
      25,   152,   152,   152,    25,    91,   152,    21,    22,    38,
     107,   117,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   148,   237,    25,   152,   239,    25,   152,
     227,    64,    65,    71,   228,    25,   152,   152,   152,    73,
      25,   152,   152,   152,    25,    91,   152,   152,   152,    25,
      91,   152,   249,   251,   253,   255,   152,   152,    28,    31,
      75,    76,    94,   235,    25,   152,    25,   152,    25,   152,
     155,   155,   155,   155,   155,   155,   155,   155,   155,   155,
     155,   155,   155,   155,   155,   155,   155,    15,    43,    44,
      45,    46,   238,    15,    47,    48,   240,    15,    25,   152,
     228,    25,   152,    25,   152,    15,    25,   152,    73,    25,
     152,    25,   152,    29,   152,    25,    36,    37,   258,   259,
     261,    27,    27,    90,    25,   152,   236,    25,   152,    25,
      91,   152,   238,   240,    73,    80,    81,    82,   250,   252,
     254,    11,    35,   256,   260,   256,   233,     7,    13,    15,
     152,    25,   152,   256,   256,   256,   259,   257,    11,    27,
       7,   152,   256,   260,   260,   234,    11,    28,   260
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   150,   151,   152,   152,   153,   154,   154,   155,   155,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   163,
     164,   165,   166,   167,   168,   169,   169,   169,   169,   170,
     171,   172,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   201,   202,   202,   203,   204,   204,   205,   205,
     206,   207,   208,   209,   210,   211,   212,   212,   213,   214,
     215,   216,   216,   216,   216,   216,   216,   217,   217,   218,
     219,   219,   219,   219,   219,   220,   221,   221,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   223,   224,   225,   225,   226,
     226,   226,   226,   226,   226,   226,   226,   226,   226,   226,
     226,   226,   226,   226,   226,   226,   226,   226,   226,   226,
     226,   226,   226,   226,   226,   226,   226,   226,   226,   226,
     226,   227,   227,   227,   227,   228,   228,   228,   228,   229,
     230,   230,   231,   231,   231,   232,   233,   232,   234,   234,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   236,
     236,   236,   236,   236,   236,   237,   237,   237,   238,   238,
     238,   238,   239,   239,   239,   240,   240,   241,   241,   242,
     243,   243,   244,   244,   244,   244,   244,   244,   244,   245,
     246,   247,   247,   249,   250,   248,   251,   252,   248,   253,
     254,   248,   255,   248,   248,   257,   256,   256,   258,   258,
     258,   258,   258,   258,   259,   260,   261,   262,   263,   263,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     1,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     4,
       2,     2,     2,     2,     2,     4,     0,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     2,     3,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     2,     4,     0,     2,     2,
       2,     3,     2,     2,     3,     3,     2,     2,     2,     2,
       3,     3,     4,     4,     4,     4,     2,     2,     2,     2,
       2,     2,     1,     1,     2,     2,     3,     3,     2,     2,
       1,     0,     2,     2,     2,     0,     2,     2,     2,     4,
       0,     2,     2,     4,     4,     3,     0,     8,     0,     2,
       2,     2,     2,     2,     2,     3,     3,     2,     2,     0,
       2,     2,     3,     3,     2,     0,     2,     3,     1,     1,
       1,     1,     0,     2,     3,     1,     1,     2,     2,     4,
       0,     2,     1,     2,     2,     3,     3,     2,     2,     2,
       4,     0,     2,     0,     0,     5,     0,     0,     5,     0,
       0,     5,     0,     3,     1,     0,     5,     3,     2,     1,
       4,     3,     2,     1,     1,     1,     1,     1,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 214 "sg.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2092 "y.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 215 "sg.y" /* yacc.c:1646  */
    { (yyval.string) = (yyvsp[0].string); }
#line 2098 "y.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 219 "sg.y" /* yacc.c:1646  */
    { httpsConnectionCacheSize = atoi( (yyvsp[0].string) ); 
		                                         ufdbFree( (yyvsp[0].string) ); }
#line 2105 "y.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 224 "sg.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_ALLOW; }
#line 2111 "y.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 225 "sg.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_DENY; }
#line 2117 "y.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 229 "sg.y" /* yacc.c:1646  */
    { (yyval.integer) = 1; }
#line 2123 "y.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 230 "sg.y" /* yacc.c:1646  */
    { (yyval.integer) = 0; }
#line 2129 "y.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 231 "sg.y" /* yacc.c:1646  */
    { ufdbLogFatalError( "syntax error at line %d: expected 'on' or 'off'", lineno );   }
#line 2135 "y.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 235 "sg.y" /* yacc.c:1646  */
    { UFDBglobalLogPass = (yyvsp[0].integer); }
#line 2141 "y.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 239 "sg.y" /* yacc.c:1646  */
    { UFDBglobalLogBlock = (yyvsp[0].integer); }
#line 2147 "y.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 243 "sg.y" /* yacc.c:1646  */
    { UFDBglobalLogAllRequests = (yyvsp[0].integer); }
#line 2153 "y.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 247 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugHttpd = (yyvsp[0].integer); }
#line 2159 "y.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 251 "sg.y" /* yacc.c:1646  */
    { UFDBglobalYoutubeEdufilter = (yyvsp[0].integer); }
#line 2165 "y.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 255 "sg.y" /* yacc.c:1646  */
    { UFDBglobalYoutubeEdufilterID = (yyvsp[0].string); }
#line 2171 "y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 259 "sg.y" /* yacc.c:1646  */
    { UFDBglobalAllowGoogleHTTPSusingIP = (yyvsp[0].integer); }
#line 2177 "y.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 263 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebug = (yyvsp[0].integer); }
#line 2183 "y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 264 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebug = atoi( (yyvsp[0].string) );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2190 "y.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 269 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugCoreDump = (yyvsp[0].integer); }
#line 2196 "y.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 274 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: option enforce-https-with-hostname must be part of "
                                    "the security category", lineno );  }
#line 2203 "y.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 280 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: option enforce-https-official-certificate must be part of "
                                  "the security category", lineno );  }
#line 2210 "y.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 286 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv2 must be part of "
                                    "the security category", lineno );  }
#line 2217 "y.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 292 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: option https-prohibit-insecure-sslv3 must be part of "
                                    "the security category", lineno );  }
#line 2224 "y.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 298 "sg.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_OFF; }
#line 2230 "y.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 299 "sg.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_QUEUE_CHECKS; }
#line 2236 "y.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 300 "sg.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_API_HTTPS_CHECK_AGGRESSIVE; }
#line 2242 "y.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 301 "sg.y" /* yacc.c:1646  */
    { (yyval.integer) = UFDB_API_HTTPS_LOG_ONLY; }
#line 2248 "y.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 305 "sg.y" /* yacc.c:1646  */
    { UFDBsetTunnelCheckMethod( (yyvsp[0].integer) ); }
#line 2254 "y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 309 "sg.y" /* yacc.c:1646  */
    { ufdbSetting("administrator",(yyvsp[0].string)); }
#line 2260 "y.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 313 "sg.y" /* yacc.c:1646  */
    { ufdbSetting("dbhome",(yyvsp[0].string)); }
#line 2266 "y.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 314 "sg.y" /* yacc.c:1646  */
    { ufdbSetting("dbhome",(yyvsp[0].string)); }
#line 2272 "y.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 318 "sg.y" /* yacc.c:1646  */
    { setRefreshUserlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2279 "y.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 323 "sg.y" /* yacc.c:1646  */
    { setRefreshIPlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2286 "y.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 328 "sg.y" /* yacc.c:1646  */
    { setRefreshDomainlist( atoi((yyvsp[0].string)) );
		                                ufdbFree( (yyvsp[0].string) ); }
#line 2293 "y.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 334 "sg.y" /* yacc.c:1646  */
    { UFDBglobalURLlookupResultDBreload = (yyvsp[0].integer); }
#line 2299 "y.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 338 "sg.y" /* yacc.c:1646  */
    { UFDBglobalURLlookupResultFatalError = (yyvsp[0].integer); }
#line 2305 "y.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 342 "sg.y" /* yacc.c:1646  */
    { UFDBglobalURLlookupDelayDBreload = (yyvsp[0].integer); }
#line 2311 "y.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 346 "sg.y" /* yacc.c:1646  */
    { ufdbFree( UFDBglobalSquidVersion );  UFDBglobalSquidVersion = (yyvsp[0].string);  }
#line 2317 "y.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 351 "sg.y" /* yacc.c:1646  */
    { int new_n_workers;
					  /* ONLY increase #workers */
					  new_n_workers = atoi( (yyvsp[0].string) );  
		                          ufdbFree( (yyvsp[0].string) );
					  if (new_n_workers < UFDB_MIN_THREADS)
					  {
					     ufdbLogError( "num-worker-threads must be at least %d",
                                                           UFDB_MIN_THREADS );
					     new_n_workers = UFDB_MIN_THREADS;
					  }
					  else if (new_n_workers > UFDB_MAX_THREADS)
					  {
					     ufdbLogError( "num-worker-threads can be at most %d",
                                                           UFDB_MAX_THREADS );
					     new_n_workers = UFDB_MAX_THREADS;
					  }
					  if (new_n_workers > UFDBglobalNworkers)
					     UFDBglobalNworkers = new_n_workers;
					}
#line 2341 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 374 "sg.y" /* yacc.c:1646  */
    { UFDBglobalUploadCrashReports = (yyvsp[0].integer);  }
#line 2347 "y.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 379 "sg.y" /* yacc.c:1646  */
    { UFDBglobalLookupReverseIP = (yyvsp[0].integer);  }
#line 2353 "y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 384 "sg.y" /* yacc.c:1646  */
    { UFDBglobalUseAlsoIPv6onWan = (yyvsp[0].integer);  }
#line 2359 "y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 389 "sg.y" /* yacc.c:1646  */
    { UFDBglobalSquidUsesActiveBumping = (yyvsp[0].integer);  }
#line 2365 "y.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 393 "sg.y" /* yacc.c:1646  */
    { UFDBglobalLogURLdetails = (yyvsp[0].integer); }
#line 2371 "y.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 397 "sg.y" /* yacc.c:1646  */
    { UFDBglobalShowURLdetails = (yyvsp[0].integer); }
#line 2377 "y.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 401 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugSkype = (yyvsp[0].integer); }
#line 2383 "y.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 405 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugGtalk = (yyvsp[0].integer); }
#line 2389 "y.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 409 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugYahooMsg = (yyvsp[0].integer); }
#line 2395 "y.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 413 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugAim = (yyvsp[0].integer); }
#line 2401 "y.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 417 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugFBchat = (yyvsp[0].integer); }
#line 2407 "y.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 421 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugCitrixOnline = (yyvsp[0].integer); }
#line 2413 "y.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 425 "sg.y" /* yacc.c:1646  */
    { UFDBglobalExpressionOptimisation = (yyvsp[0].integer); }
#line 2419 "y.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 429 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugRegexp = (yyvsp[0].integer); }
#line 2425 "y.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 433 "sg.y" /* yacc.c:1646  */
    { UFDBglobalDebugExternalScripts = (yyvsp[0].integer); }
#line 2431 "y.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 437 "sg.y" /* yacc.c:1646  */
    { ufdbFree( UFDBglobalEmailServer ); UFDBglobalEmailServer = (yyvsp[0].string); }
#line 2437 "y.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 441 "sg.y" /* yacc.c:1646  */
    { ufdbFree( UFDBglobalMyHostname ); UFDBglobalMyHostname = (yyvsp[0].string); }
#line 2443 "y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 445 "sg.y" /* yacc.c:1646  */
    { ufdbFree( UFDBglobalAdminEmail ); UFDBglobalAdminEmail = (yyvsp[0].string); }
#line 2449 "y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 449 "sg.y" /* yacc.c:1646  */
    { ufdbFree( UFDBglobalSenderEmail ); UFDBglobalSenderEmail = (yyvsp[0].string); }
#line 2455 "y.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 453 "sg.y" /* yacc.c:1646  */
    {  ufdbFree( UFDBglobalExternalStatusCommand );  UFDBglobalExternalStatusCommand = (yyvsp[0].string); }
#line 2461 "y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 457 "sg.y" /* yacc.c:1646  */
    { ufdbSetting("logdir",(yyvsp[0].string)); }
#line 2467 "y.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 458 "sg.y" /* yacc.c:1646  */
    { ufdbSetting("logdir",(yyvsp[0].string)); }
#line 2473 "y.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 462 "sg.y" /* yacc.c:1646  */
    { ufdbSetting("pidfile",(yyvsp[0].string)); }
#line 2479 "y.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 463 "sg.y" /* yacc.c:1646  */
    { ufdbSetting("pidfile",(yyvsp[0].string)); }
#line 2485 "y.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 467 "sg.y" /* yacc.c:1646  */
    { ufdbSetting( "port", (yyvsp[0].string) ); }
#line 2491 "y.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 471 "sg.y" /* yacc.c:1646  */
    { 
#if HAVE_UNIX_SOCKETS
                                             ufdbLogError( "ufdbguardd is configured to use UNIX sockets.  \"interface\" is ignored." );
#else
		                             if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( UFDBglobalInterface, "all" );    
					     else
					        ufdbLogFatalError( "interface must be \"all\" or IP address" );
#endif
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2507 "y.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 482 "sg.y" /* yacc.c:1646  */
    { strcpy( UFDBglobalInterface, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) ); }
#line 2513 "y.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 486 "sg.y" /* yacc.c:1646  */
    { ufdbSetCPU( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2519 "y.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 487 "sg.y" /* yacc.c:1646  */
    { ufdbSetCPU( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2525 "y.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 492 "sg.y" /* yacc.c:1646  */
    { UFDBglobalUploadStats = (yyvsp[0].integer);   }
#line 2531 "y.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 497 "sg.y" /* yacc.c:1646  */
    { strcpy( UFDBglobalRedirectHttps, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2537 "y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 502 "sg.y" /* yacc.c:1646  */
    { strcpy( UFDBglobalRedirectBumpedHttps, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2543 "y.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 507 "sg.y" /* yacc.c:1646  */
    { strcpy( UFDBglobalLoadingDatabaseRedirect, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2549 "y.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 512 "sg.y" /* yacc.c:1646  */
    { strcpy( UFDBglobalFatalErrorRedirect, (yyvsp[0].string) );  ufdbFree( (yyvsp[0].string) );  }
#line 2555 "y.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 517 "sg.y" /* yacc.c:1646  */
    {
			UFDBglobalLogUncategorisedURLs = (yyvsp[0].integer);   
		     }
#line 2563 "y.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 524 "sg.y" /* yacc.c:1646  */
    { 
			UFDBglobalAnalyseUncategorisedURLs = (yyvsp[0].integer);   
		     }
#line 2571 "y.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 529 "sg.y" /* yacc.c:1646  */
    {
			UFDBglobalAnalyseUncategorisedURLs = atoi( (yyvsp[0].string) ); 
			ufdbFree( (yyvsp[0].string) ); 
		     }
#line 2580 "y.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 537 "sg.y" /* yacc.c:1646  */
    {
		        UFDBglobalStripDomainFromUsername = (yyvsp[0].integer);
		     }
#line 2588 "y.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 544 "sg.y" /* yacc.c:1646  */
    { UFDBglobalSafeSearch = (yyvsp[0].integer); }
#line 2594 "y.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 549 "sg.y" /* yacc.c:1646  */
    { 
		       UFDBglobalMaxLogfileSize = strtoul( (yyvsp[0].string), NULL, 10 );
		       ufdbFree( (yyvsp[0].string) );
		       if (UFDBglobalMaxLogfileSize < 2 * 1024 * 1024)		/* minimum is 2 MB */
		          UFDBglobalMaxLogfileSize = 2 * 1024 * 1024;
		       if (UFDBglobalMaxLogfileSize > 2000000000)		/* maximum is 2 GB */
		          UFDBglobalMaxLogfileSize = 2000000000;
		     }
#line 2607 "y.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 560 "sg.y" /* yacc.c:1646  */
    { UFDBglobalHttpdPort = atoi( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2613 "y.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 561 "sg.y" /* yacc.c:1646  */
    { if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( UFDBglobalHttpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2624 "y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 567 "sg.y" /* yacc.c:1646  */
    { if (strcmp((yyvsp[0].string),"all")== 0)
						strcpy( UFDBglobalHttpdInterface, "all" );    
					     else
					        ufdbLogFatalError( "http-server interface must be \"all\" or IP address" );
					     ufdbFree( (yyvsp[0].string) );
					   }
#line 2635 "y.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 573 "sg.y" /* yacc.c:1646  */
    { strcpy( UFDBglobalHttpdInterface, (yyvsp[0].string) );       ufdbFree( (yyvsp[0].string) ); }
#line 2641 "y.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 574 "sg.y" /* yacc.c:1646  */
    { strcpy( UFDBglobalHttpdImagesDirectory, (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2647 "y.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 575 "sg.y" /* yacc.c:1646  */
    { strcpy( UFDBglobalHttpdImagesDirectory, (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 2653 "y.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 588 "sg.y" /* yacc.c:1646  */
    { ufdbCategory( (yyvsp[0].string) ); }
#line 2659 "y.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 589 "sg.y" /* yacc.c:1646  */
    { ufdbCategory( ufdbStrdup("aggressive") );
		                         yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 2666 "y.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 591 "sg.y" /* yacc.c:1646  */
    { ufdbCategory( ufdbStrdup("allow") );
		                         yyerror( (char *) "\"allow\" is a keyword and must be surrounded by quotes" ); }
#line 2673 "y.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 593 "sg.y" /* yacc.c:1646  */
    { ufdbCategory( ufdbStrdup("deny") );
		                         yyerror( (char *) "\"deny\" is a keyword and must be surrounded by quotes" ); }
#line 2680 "y.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 595 "sg.y" /* yacc.c:1646  */
    { ufdbCategory( ufdbStrdup("syntax-error") );
		                         yyerror( (char *) "erroneous category definition.  Perhaps the category ID is a reserved word?" ); }
#line 2687 "y.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 601 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryEnd(); }
#line 2693 "y.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 609 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryDomainList( (yyvsp[0].string) ); }
#line 2699 "y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 610 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryDomainList( (yyvsp[0].string) ); }
#line 2705 "y.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 611 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryDomainList( NULL ); }
#line 2711 "y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 612 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryExecDomainList( (yyvsp[0].string) ); }
#line 2717 "y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 613 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryUrlList( (yyvsp[0].string) ); }
#line 2723 "y.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 614 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryUrlList( (yyvsp[0].string) ); }
#line 2729 "y.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 615 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryUrlList( NULL ); }
#line 2735 "y.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 616 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "n" ); }
#line 2741 "y.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 617 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "n" ); }
#line 2747 "y.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 618 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( NULL, NULL ); }
#line 2753 "y.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 619 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2759 "y.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 620 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2765 "y.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 621 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2771 "y.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 622 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryExpressionList( (yyvsp[0].string), "i" ); }
#line 2777 "y.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 623 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryCACertsFile( (yyvsp[0].string) ); }
#line 2783 "y.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 624 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryCACertsFile( (yyvsp[0].string) ); }
#line 2789 "y.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 625 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryCACertsDir( (yyvsp[0].string) ); }
#line 2795 "y.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 626 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryCACertsDir( (yyvsp[0].string) ); }
#line 2801 "y.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 627 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryRedirect( (yyvsp[0].string) ); }
#line 2807 "y.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 628 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryRedirect( (yyvsp[0].string) ); }
#line 2813 "y.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 629 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryRewrite( (yyvsp[0].string) ); }
#line 2819 "y.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 630 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryRewrite( (yyvsp[0].string) ); }
#line 2825 "y.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 631 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 2831 "y.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 632 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 2837 "y.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 633 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryBlockConnect( (yyvsp[0].integer) ); }
#line 2843 "y.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 634 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryActiveBumping( (yyvsp[0].integer) ); }
#line 2849 "y.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 635 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_SAFE_SEARCH );  }
#line 2855 "y.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 636 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_YOUTUBE_EDUFILTER );  }
#line 2861 "y.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 637 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
#line 2867 "y.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 638 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_HTTPS_WITH_HOSTNAME );  }
#line 2873 "y.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 639 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption(  1, UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
#line 2879 "y.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 640 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE );  }
#line 2885 "y.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 641 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV2 );  }
#line 2891 "y.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 642 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_PROHIBIT_INSECURE_SSLV3 );  }
#line 2897 "y.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 643 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_SKYPE_OVER_HTTPS );  }
#line 2903 "y.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 644 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_GTALK_OVER_HTTPS );  }
#line 2909 "y.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 645 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_YAHOOMSG_OVER_HTTPS );  }
#line 2915 "y.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 646 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_AIM_OVER_HTTPS );  }
#line 2921 "y.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 647 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_FBCHAT_OVER_HTTPS );  }
#line 2927 "y.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 648 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_CITRIXONLINE_OVER_HTTPS );  }
#line 2933 "y.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 649 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_ANYDESK_OVER_HTTPS );  }
#line 2939 "y.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 650 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_TEAMVIEWER_OVER_HTTPS );  }
#line 2945 "y.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 651 "sg.y" /* yacc.c:1646  */
    { ufdbCategoryOption( (yyvsp[0].integer), UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS );  }
#line 2951 "y.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 652 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2958 "y.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 654 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2965 "y.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 656 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2972 "y.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 658 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 2979 "y.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 663 "sg.y" /* yacc.c:1646  */
    { defSource( (yyvsp[0].string) ); }
#line 2985 "y.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 667 "sg.y" /* yacc.c:1646  */
    { defSourceEnd(); }
#line 2991 "y.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 679 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 2997 "y.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 680 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 3003 "y.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 681 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 3009 "y.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 682 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUserList( (yyvsp[0].string) ); }
#line 3015 "y.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 683 "sg.y" /* yacc.c:1646  */
    { ufdbSourceExecUserList( (yyvsp[0].string) ); }
#line 3021 "y.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 684 "sg.y" /* yacc.c:1646  */
    { ufdbSourceExecIPList( (yyvsp[0].string) ); }
#line 3027 "y.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 685 "sg.y" /* yacc.c:1646  */
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 3033 "y.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 686 "sg.y" /* yacc.c:1646  */
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 3039 "y.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 687 "sg.y" /* yacc.c:1646  */
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 3045 "y.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 688 "sg.y" /* yacc.c:1646  */
    { ufdbSourceGroup( UFDB_GROUPTYPE_UNIX, (yyvsp[0].string) ); }
#line 3051 "y.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 689 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "3600" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 3058 "y.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 691 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "86400" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 3065 "y.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 693 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), "604800" );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); }
#line 3072 "y.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 695 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUserQuota( (yyvsp[-2].string), (yyvsp[-1].string), (yyvsp[0].string) );  
		                                   ufdbFree( (yyvsp[-2].string) ); ufdbFree( (yyvsp[-1].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 3079 "y.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 698 "sg.y" /* yacc.c:1646  */
    { defSourceIPV4List( (yyvsp[0].string) ); }
#line 3085 "y.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 699 "sg.y" /* yacc.c:1646  */
    { defSourceIPV4List( (yyvsp[0].string) ); }
#line 3091 "y.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 701 "sg.y" /* yacc.c:1646  */
    { defSourceIPV6List( (yyvsp[0].string) ); }
#line 3097 "y.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 702 "sg.y" /* yacc.c:1646  */
    { defSourceIPV6List( (yyvsp[0].string) ); }
#line 3103 "y.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 703 "sg.y" /* yacc.c:1646  */
    { ufdbSourceEval( UFDB_EVAL_AND ); }
#line 3109 "y.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 704 "sg.y" /* yacc.c:1646  */
    { ufdbSourceEval( UFDB_EVAL_OR ); }
#line 3115 "y.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 705 "sg.y" /* yacc.c:1646  */
    { defSourceTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 3121 "y.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 706 "sg.y" /* yacc.c:1646  */
    { defSourceTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 3127 "y.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 707 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3135 "y.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 710 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3143 "y.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 713 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3151 "y.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 716 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
                                                                 lineno, (yyvsp[0].string) ); 
						   ufdbFree( (yyvsp[0].string) ); }
#line 3159 "y.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 719 "sg.y" /* yacc.c:1646  */
    { lastSource->cont_search = 1; }
#line 3165 "y.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 725 "sg.y" /* yacc.c:1646  */
    { defSourceDomain( (yyvsp[0].string) ); }
#line 3171 "y.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 726 "sg.y" /* yacc.c:1646  */
    { defSourceDomain( (yyvsp[0].string) ); }
#line 3177 "y.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 732 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUser( (yyvsp[0].string) ); }
#line 3183 "y.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 733 "sg.y" /* yacc.c:1646  */
    { ufdbSourceUser( (yyvsp[0].string) ); }
#line 3189 "y.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 746 "sg.y" /* yacc.c:1646  */
    { sgAcl( (yyvsp[-1].string), NULL, UFDB_ACL_NONE );  }
#line 3195 "y.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 747 "sg.y" /* yacc.c:1646  */
    { sgAcl( (yyvsp[-3].string), (yyvsp[-1].string), UFDB_ACL_WITHIN );  }
#line 3201 "y.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 748 "sg.y" /* yacc.c:1646  */
    { sgAcl( (yyvsp[-3].string), (yyvsp[-1].string), UFDB_ACL_OUTSIDE ); }
#line 3207 "y.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 754 "sg.y" /* yacc.c:1646  */
    { sgAcl( NULL, NULL, UFDB_ACL_ELSE );    }
#line 3213 "y.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 764 "sg.y" /* yacc.c:1646  */
    { if (lastAcl != NULL  &&  lastAcl->pass == NULL) 
                                                  {
                                                     ufdbLogMessage( "line %d: acl has an empty pass statement.  Adding 'any'.", lineno );
                                                     sgAclSetValue( "pass", ufdbStrdup("any"), 1 );
                                                  }
                                                }
#line 3224 "y.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 770 "sg.y" /* yacc.c:1646  */
    { sgAclSetValue( "rewrite", (yyvsp[0].string), 0 ); }
#line 3230 "y.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 771 "sg.y" /* yacc.c:1646  */
    { sgAclSetValue( "rewrite", (yyvsp[0].string), 0 ); }
#line 3236 "y.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 772 "sg.y" /* yacc.c:1646  */
    { sgAclSetValue( "redirect", (yyvsp[0].string), 0 ); }
#line 3242 "y.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 773 "sg.y" /* yacc.c:1646  */
    { sgAclSetValue( "redirect", (yyvsp[0].string), 0 ); }
#line 3248 "y.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 774 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3255 "y.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 776 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3262 "y.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 778 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3269 "y.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 780 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s", lineno, (yyvsp[0].string) ); 
						  ufdbFree( (yyvsp[0].string) ); }
#line 3276 "y.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 786 "sg.y" /* yacc.c:1646  */
    { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 3282 "y.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 787 "sg.y" /* yacc.c:1646  */
    { sgAclSetValue( "pass", (yyvsp[0].string), 1 ); }
#line 3288 "y.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 788 "sg.y" /* yacc.c:1646  */
    { yyerror( (char *) "\"aggressive\" is a keyword and must be surrounded by quotes" ); }
#line 3294 "y.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 789 "sg.y" /* yacc.c:1646  */
    { sgAclSetValue( "pass", (yyvsp[0].string), 0 ); }
#line 3300 "y.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 800 "sg.y" /* yacc.c:1646  */
    { sgIpv4( (yyvsp[0].string), SG_IPTYPE_HOST, UFDBglobalConfigFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) );  }
#line 3307 "y.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 802 "sg.y" /* yacc.c:1646  */
    { sgIpv4( (yyvsp[0].string), SG_IPTYPE_RANGE, UFDBglobalConfigFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) );  }
#line 3314 "y.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 804 "sg.y" /* yacc.c:1646  */
    { sgIpv4( (yyvsp[0].string), SG_IPTYPE_CLASS, UFDBglobalConfigFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 3321 "y.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 806 "sg.y" /* yacc.c:1646  */
    { sgIpv4( (yyvsp[0].string), SG_IPTYPE_CIDR, UFDBglobalConfigFile, lineno );
		                                  ufdbFree( (yyvsp[0].string) ); }
#line 3328 "y.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 817 "sg.y" /* yacc.c:1646  */
    { sgIpv6( (yyvsp[0].string), SG_IPV6TYPE_HOST, UFDBglobalConfigFile, lineno );
                                                  ufdbFree( (yyvsp[0].string) );  }
#line 3335 "y.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 819 "sg.y" /* yacc.c:1646  */
    { sgIpv6( (yyvsp[0].string), SG_IPV6TYPE_CIDR, UFDBglobalConfigFile, lineno );
                                                  ufdbFree( (yyvsp[0].string) );  }
#line 3342 "y.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 824 "sg.y" /* yacc.c:1646  */
    { sgRewrite( (yyvsp[0].string) ); }
#line 3348 "y.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 825 "sg.y" /* yacc.c:1646  */
    { sgRewrite( (yyvsp[0].string) ); }
#line 3354 "y.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 839 "sg.y" /* yacc.c:1646  */
    { sgRewriteSubstitute( (yyvsp[0].string) ); ufdbFree( (yyvsp[0].string) ); }
#line 3360 "y.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 840 "sg.y" /* yacc.c:1646  */
    { sgRewriteTime( (yyvsp[0].string), UFDB_ACL_WITHIN ); }
#line 3366 "y.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 841 "sg.y" /* yacc.c:1646  */
    { sgRewriteTime( (yyvsp[0].string), UFDB_ACL_OUTSIDE ); }
#line 3372 "y.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 842 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3380 "y.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 845 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3388 "y.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 848 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3396 "y.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 851 "sg.y" /* yacc.c:1646  */
    { ufdbLogError( "line %d: unsupported logfile context for %s",
		                                                lineno, (yyvsp[0].string) );
								ufdbFree( (yyvsp[0].string) ); }
#line 3404 "y.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 858 "sg.y" /* yacc.c:1646  */
    { sgTime( (yyvsp[0].string) ); }
#line 3410 "y.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 872 "sg.y" /* yacc.c:1646  */
    { sgTimeElementInit(); }
#line 3416 "y.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 872 "sg.y" /* yacc.c:1646  */
    { sgTimeElementAdd((yyvsp[0].string),T_WEEKDAY); }
#line 3422 "y.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 873 "sg.y" /* yacc.c:1646  */
    { sgTimeElementInit(); }
#line 3428 "y.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 873 "sg.y" /* yacc.c:1646  */
    { sgTimeElementAdd((yyvsp[0].string),T_WEEKLY); }
#line 3434 "y.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 874 "sg.y" /* yacc.c:1646  */
    { sgTimeElementInit(); }
#line 3440 "y.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 874 "sg.y" /* yacc.c:1646  */
    { sgTimeElementAdd((yyvsp[0].string),T_WEEKLY); }
#line 3446 "y.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 875 "sg.y" /* yacc.c:1646  */
    { sgTimeElementInit(); }
#line 3452 "y.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 875 "sg.y" /* yacc.c:1646  */
    { sgTimeElementEnd(); }
#line 3458 "y.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 876 "sg.y" /* yacc.c:1646  */
    { ufdbLogFatalError( "invalid time specification at line %d", lineno );   }
#line 3464 "y.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 880 "sg.y" /* yacc.c:1646  */
    { sgTimeElementClone(); }
#line 3470 "y.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 893 "sg.y" /* yacc.c:1646  */
    { sgTimeElementAdd( (yyvsp[0].string), T_DVAL ); }
#line 3476 "y.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 896 "sg.y" /* yacc.c:1646  */
    { sgTimeElementAdd( (yyvsp[0].tval), T_TVAL ); }
#line 3482 "y.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 899 "sg.y" /* yacc.c:1646  */
    { sgTimeElementAdd( (yyvsp[0].string), T_DVALCRON ); }
#line 3488 "y.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 903 "sg.y" /* yacc.c:1646  */
    {  yyerror( (char *) "syntax error" );  }
#line 3494 "y.tab.c" /* yacc.c:1646  */
    break;


#line 3498 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 982 "sg.y" /* yacc.c:1906  */


int sgReadConfig( 
   char *            file )
{
   char *            defaultFile = (char *) DEFAULT_CONFIGFILE;
   struct Source *   source;
   struct Category * cat;
   struct Acl *      acl;

   lineno = 1;
   ufdbResetCPUs();

   UFDBglobalConfigFile = file;
   if (UFDBglobalConfigFile == NULL)
      UFDBglobalConfigFile = defaultFile;

   yyin = fopen( UFDBglobalConfigFile, "r" );
   if (yyin == NULL) 
   {
      syslog( LOG_ALERT, "%s: cannot open configuration file %s", UFDBprogname, UFDBglobalConfigFile );
      ufdbLogFatalError( "cannot open configuration file %s", UFDBglobalConfigFile );
      return 0;
   }

   ufdbLogMessage( "configuration file: %s", UFDBglobalConfigFile );

   /* keep the old HTTPS redirection URL.  It is most likely that we need it during the database reload */
   /* dot not reset UFDBglobalRedirectHttps and UFDBglobalRedirectBumpedHttps. */

   /* UFDBglobalDebug = 0; */
   /* UFDBglobalDebugCoreDump = 0; */
   strcpy( UFDBglobalInterface, "all" );
   /* UFDBglobalPortNum = UFDB_DAEMON_PORT;  the port can be set with a command line switch so do not reset it */
   /* UFDBglobalNworkers = UFDB_MIN_THREADS;  do not reset this variable. */
   UFDBglobalDebugHttpd = 0;
   UFDBglobalLogPass = 0;
   UFDBglobalLogBlock = 0;
   UFDBglobalLogAllRequests = 0;
   UFDBglobalYoutubeEdufilter = 0;
   UFDBglobalYoutubeEdufilterID = (char *) "none";
   UFDBglobalAllowGoogleHTTPSusingIP = 0;

#if 0
   /* When a database is reloaded, these variables may NOT be reset since they are used during the reload !! */
   UFDBglobalURLlookupDelayDBreload = 0;
   UFDBglobalURLlookupResultDBreload = UFDB_ALLOW;
   UFDBglobalURLlookupResultFatalError = UFDB_ALLOW;
   strcpy( UFDBglobalLoadingDatabaseRedirect, "a-blocking-url" );
   ufdbFree( UFDBglobalSquidVersion );
#endif
   if (UFDBglobalSquidVersion == NULL)
      UFDBglobalSquidVersion = ufdbStrdup( UFDB_DEFAULT_SQUID_VERSION );

   UFDBglobalShowURLdetails = 0;
   UFDBglobalLogURLdetails = 0;
   UFDBglobalUploadCrashReports = 1;
   UFDBglobalLookupReverseIP = 0;
   UFDBglobalUseAlsoIPv6onWan = 1;
   UFDBglobalDebugSkype = 0;
   UFDBglobalDebugGtalk = 0;
   UFDBglobalDebugYahooMsg = 0;
   UFDBglobalDebugAim = 0;
   UFDBglobalDebugFBchat = 0;
   UFDBglobalDebugCitrixOnline = 0;
   UFDBglobalDebugRegexp = 0;
   UFDBglobalDebugExternalScripts = 0;
   UFDBglobalExpressionOptimisation = 1;
   UFDBglobalRefreshUserlistInterval = UFDB_DEFAULT_REFRESH_USERLIST;
   UFDBglobalRefreshIPlistInterval = UFDB_DEFAULT_REFRESH_IPLIST;
   UFDBglobalRefreshDomainlistInterval = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   UFDBglobalAnalyseUncategorisedURLs = 1;
   UFDBglobalLogUncategorisedURLs = 0;
   UFDBglobalUploadStats = 1;
   UFDBglobalSafeSearch = 1;
   UFDBglobalSkipSafeCategory = 0;
   UFDBglobalStripDomainFromUsername = 0;
   UFDBglobalTunnelCheckMethod = UFDB_API_HTTPS_CHECK_OFF;
   /* do not reset: UFDBglobalSquidUsesActiveBumping = 0; */
   UFDBglobalHttpsWithHostname = 0;
   UFDBglobalHttpsOfficialCertificate = 0;
   UFDBglobalUnknownProtocolOverHttps = 1;
   UFDBglobalHttpsNoSSLv2 = 1;
   UFDBglobalHttpsNoSSLv3 = 0;
   UFDBglobalHttpdPort = 0;
   UFDBglobalDateOfCheckedDB[0] = '\0';
   strcpy( UFDBglobalHttpdInterface, "all" );
   strcpy( UFDBglobalHttpdImagesDirectory, "." );
 
   UFDBglobalDatabaseStatus = UFDB_API_STATUS_DATABASE_OK;

   (void) yyparse();		/* parse the configuration file ********************/
   fclose( yyin );

   UFDBglobalDatabaseLoadTime = time( NULL );

   /*
    * For analysis of uncategorised URLs we also load a "checked" category
    * that contains URLs that are reviewed and checked not to be part of
    * any other category.
    */
   {
      char * dbhome;
      char   dbfname[1024];

      dbhome = ufdbSettingGetValue( (char *) "dbhome" );
      if (dbhome == NULL)
         dbhome = (char *) DEFAULT_DBHOME;

      /* TODO: check if "checked" was not already loaded... */
      if (UFDBglobalAnalyseUncategorisedURLs > 0)
      {
	 int status;
	 sprintf( dbfname, "%s/checked/domains.ufdb", dbhome );
	 status = UFDBloadDatabase( &UFDBglobalCheckedDB, dbfname );
	 if (status != UFDB_API_OK  &&  status != UFDB_API_STATUS_DATABASE_OLD)
	 {
	    UFDBglobalCheckedDB.mem = NULL;
	    UFDBglobalCheckedDB.index = NULL;
	    UFDBglobalCheckedDB.table.nNextLevels = 0;
	    if (UFDBglobalDebug)
	       ufdbLogMessage( "The URL database appears not be from URLfilterDB. No problem." );
	 }
	 else
	 {
	    if (UFDBglobalDebug)
	       ufdbLogMessage( "table \"checked\" is loaded: %s %8.8s",
	                       UFDBglobalCheckedDB.date, UFDBglobalCheckedDB.flags );
	    sprintf( dbfname, "%s/checked/expressions", dbhome );
	    (void) UFDBloadExpressions( &UFDBglobalCheckedExpressions, dbfname );
	    ufdbLogMessage( "The implicitly allowed URL category 'checked' is loaded." );
	 }
      }
   }

   if (defaultAcl == NULL)
      ufdbLogFatalError( "\"default\" ACL is not defined" );
   else if (defaultAcl->pass == NULL)
      ufdbLogError( "\"default\" ACL is empty: by default all URLs are blocked." );

   /* A configuration file may have a source definition which is not used in the ACL list.
    * This raises the question "what to do with this ?".
    * If we do nothing, the source is matched but has no ACL definition and is silently skipped.
    * Most likely the administrator overlooked something so a warning is useful.
    */
   source = UFDBgetSourceList();  
   if (source == NULL  &&  defaultAcl == NULL)
      ufdbLogFatalError( "There are no sources and there is no default ACL" );

   for ( ; source != NULL;  source = source->next)
   {
      int found;

      found = 0;
      for (acl = AclList;  acl != NULL;  acl = acl->next)
      {
         if (strcmp( acl->name, source->name ) == 0)
	 {
	    found = 1;
	    break;
	 }
      }
      if (!found)
      {
         ufdbLogError( "source \"%s\" has no ACL.  *****\n"
	               "This most likely may lead to unexpected results when the source is matched.  *****\n"
		       "It is strongly suggested to remove the source definition OR add the source to the acl.  *****",
		       source->name );
	 source->active = 0;
      }
      else if (acl->pass == NULL)
      {
         ufdbLogMessage( "source \"%s\" has an empty \"pass\" in its ACL *****", source->name );
      }
   }

   for (cat = Cat;  cat != NULL;  cat = cat->next)
   {
      if (cat->options == 0  &&  cat->domainlist == NULL  &&  cat->execdomainlist == NULL  && 
          cat->expressionlist == NULL  &&  cat->rewrite == NULL  &&  cat->name != NULL)
      {
         ufdbLogError( "category \"%s\" has no content definition  *****", cat->name );
      }
   }

   if (UFDBglobalAdminEmail != NULL  &&  UFDBglobalEmailServer == NULL)
   {
      ufdbLogError( "No email server is defined; cannot send email to \"%s\"  *****", UFDBglobalAdminEmail );
   }
   if (UFDBglobalAdminEmail != NULL  &&  UFDBglobalEmailServer != NULL  &&  UFDBglobalSenderEmail == NULL)
   {
      ufdbLogMessage( "WARNING: No sender email address is defined; using \"%s\" as sender", UFDBglobalAdminEmail );
   }

   if (strncmp( UFDBglobalSquidVersion, "5.", 2 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "4.", 2 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.5", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.4", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.3", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.2", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.1", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "3.0", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "2.7", 3 ) != 0  &&
       strncmp( UFDBglobalSquidVersion, "2.6", 3 ) != 0)
   {
      ufdbLogFatalError( "Unsupported Squid version \"%s\"  *****\n"
                         "The supported values for squid-version are: "
                         "5.x, 4.x, 3.5, 3.4, 3.3, 3.2, 3.1, 3.0, 2.7, 2.6  *****\n"
			 "If the version of Squid is higher, it is recommended to upgrade ufdbGuard.  *****\n"
			 "Alternatively set squid-version to the highest supported version",
			 UFDBglobalSquidVersion );
   }
   if (strncmp( UFDBglobalSquidVersion, "5.", 2 ) == 0  ||
       strncmp( UFDBglobalSquidVersion, "4.", 2 ) == 0  ||  
       strncmp( UFDBglobalSquidVersion, "3.5", 3 ) == 0  ||  
       strncmp( UFDBglobalSquidVersion, "3.4", 3 ) == 0)
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL3;
   else if (strncmp( UFDBglobalSquidVersion, "2.6", 3 ) == 0  ||  
            strncmp( UFDBglobalSquidVersion, "2.7", 3 ) == 0)
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL1;
   else
      UFDBglobalSquidHelperProtocol = UFDB_SQUID_HELPER_PROTOCOL2;	/* 3.0 - 3.3 */

   BuildImplicitPassLists();

   return 1;
}


static void setRefreshUserlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshuserlist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_USERLIST );
      nmin = UFDB_DEFAULT_REFRESH_USERLIST;
   }
   UFDBglobalRefreshUserlistInterval = nmin;
}


static void setRefreshIPlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshiplist must have a value between 5 and %d, resetting to %d.", 
                    24*60, UFDB_DEFAULT_REFRESH_IPLIST );
      nmin = UFDB_DEFAULT_REFRESH_IPLIST;
   }
   UFDBglobalRefreshIPlistInterval = nmin;
}


static void setRefreshDomainlist( int nmin )
{
   if (nmin < 5  ||  nmin > 24*60)
   {
      ufdbLogError( "refreshdomainlist must have a value between 5 and %d, resetting to %d.", 24*60, UFDB_DEFAULT_REFRESH_DOMAINLIST );
      nmin = UFDB_DEFAULT_REFRESH_DOMAINLIST;
   }
   UFDBglobalRefreshDomainlistInterval = nmin;
}


/*
 * Source functions
 */

void defSource( 
   char *          source )
{
   struct Source * sp;

   if (UFDBglobalDebug)
      ufdbLogMessage( "defSource: defining source \"%s\"", source );

   if ((struct Source *) defSourceFindName(source) != NULL)
   {
      ufdbLogFatalError( "line %d: source %s is already defined in configuration file %s",
			 lineno, source, UFDBglobalConfigFile );
      ufdbFree( source );
      return;
   }

   sp = (struct Source *) ufdbMallocAligned( 64, sizeof(struct Source) );
   sp->name = source;
   sp->active = 1;
   sp->evaluationMethod = UFDB_EVAL_OR;
   sp->ipv4hosts = NULL;
   sp->ipv4 = NULL;
   sp->ipv6hosts = NULL;
   sp->ipv6 = NULL;
   sp->domainDb = NULL;
   sp->userDb = NULL;
   sp->time = NULL;
   sp->within = UFDB_ACL_NONE;
   sp->cont_search = 0;
   sp->sarg0 = NULL;
   sp->execiplistCommand = NULL;
   sp->next = NULL;
   sp->nblocks = 0;
   sp->nmatches = 0;

   if (UFDBgetSourceList() == NULL)
   {
      if (UFDBglobalDebug)
         ufdbLogMessage( "defSource: SourceList is set to point to \"%s\"", source );
      UFDBsetSourceList( sp );
      lastSource = sp;
   }
   else
   {
      lastSource->next = sp;
      lastSource = sp;
   }
}


void defSourceEnd( void )
{
   struct Source * s;

   s = lastSource;
   if (s->ipv4 == NULL  &&  s->ipv4hosts == NULL  &&  
       s->ipv6 == NULL  &&  s->ipv6hosts == NULL  &&
       s->domainDb == NULL  &&  s->userDb == NULL)
   {
      if (s->execiplistCommand == NULL)
      {
	 ufdbLogError( "source \"%s\" missing active content, set inactive  *****",
	               s->name );
	 s->time = NULL;
	 s->active = 0;
      }
      else
	 ufdbLogError( "source \"%s\" has an execiplist command but the list is empty and set inactive   *****",
	               s->name );
   }
}


void ufdbSourceUser( 
   char *               user )
{
   char *               lc;
   struct Source *      sp;

   sp = lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "user \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         user, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL)
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }

   for (lc = user; *lc != '\0'; lc++)    /* convert username to lowercase chars */
   {
      if (*lc <= 'Z'  &&  *lc >= 'A')
         *lc += 'a' - 'A';
   }

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbSourceUser: adding user \"%s\"", user );

   sp->userDb->entries++;
   UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
   ufdbFree( user );
}


static void ufdbSourceUnixGroup(
   char *          groupName  )
{
   struct Source * sp;
   struct group *  grp;
   int             n;
   char *          user;

   sp = lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "unix group \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         groupName, sp->name, lineno );
      return;
   }
   if (sp->userDb == NULL) 
   {
      sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      sp->userDb->dbhome = NULL;
      sp->userDb->dbcp = (void *) UFDBmemDBinit();
      sp->userDb->type = SGDBTYPE_USERLIST;
      sp->userDb->entries = 0;
   }
 
   n = 0;
   setgrent();
   errno = 0;
   grp = getgrnam( groupName );
   if (grp != NULL)
   {
      if (UFDBglobalDebug > 1)
         ufdbLogMessage( "found group \"%s\"", grp->gr_name );

      while ((user = grp->gr_mem[n]) != NULL)
      {
	 char * lc;

	 if (UFDBglobalDebug > 1)
	    ufdbLogMessage( "group \"%s\" has user \"%s\"", grp->gr_name, user );
	 for (lc = user; *lc != '\0'; lc++)  	/* convert username to lowercase chars */
	 {
	    if (*lc <= 'Z'  &&  *lc >= 'A')
	       *lc += 'a' - 'A';
	 }
	 UFDBmemDBinsert( (struct UFDBmemDB *) sp->userDb->dbcp, user, NULL );
	 sp->userDb->entries++;
	 n++;
      }
      ufdbLogMessage( "source \"%s\": unix group \"%s\" has %d members", sp->name, groupName, n );
      if (n == 0)
	 ufdbLogMessage( "WARNING: source \"%s\": \"%s\" is an empty group  +++++", sp->name, groupName );
   }
   else
   {
      ufdbLogFatalError( "source \"%s\": \"%s\" is not a unix group", sp->name, groupName );
      if (errno)
	 ufdbLogError( "ufdbSourceUnixGroup: getgrnam returned error %d: %s", errno, strerror(errno) );
   }
   endgrent();
}


static void ufdbSourceGroup( 
   int    groupType,
   char * groupName  )
{
   switch (groupType)
   {
   case UFDB_GROUPTYPE_UNIX:
      ufdbSourceUnixGroup( groupName );
      break;
   default:     
      ufdbLogFatalError( "ufdbSourceGroup: unknown group type %d", groupType );
   }

   ufdbFree( groupName );
}


struct sgDb * UFDBretrieveExecDomainlist( struct Category * cat )
{
   char *        t;
   FILE *        fp;
   struct sgDb * newdb;
   int           exitcode;
   struct stat   Stat0;
   struct stat   Stat1;
   char          line[1024];
   char          basefilename[1024];
   char          fullfilename[1024];
   char          command[3000];

   if (cat == NULL)
   {
      ufdbLogFatalError( "UFDBretrieveExecDomainlist: category is NULL" );
      return NULL;
   }

   if (cat->domainlist == NULL)
   {
      ufdbLogError( "will not execute command for category %s since domainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->execdomainlist == NULL)
   {
      ufdbLogError( "can't execute command for category %s since execdomainlist is undefined", cat->name );
      return NULL;
   }

   if (cat->domainlist[0] == '/')
   {
      strcpy( basefilename, cat->domainlist );
   }
   else
   {
      char * dbhome;
      dbhome = ufdbSettingGetValue( "dbhome" );
      if (dbhome == NULL)
	 dbhome = (char *) DEFAULT_DBHOME;
      sprintf( basefilename, "%s/%s", dbhome, cat->domainlist );
   }
   strcpy( fullfilename, basefilename );
   strcat( fullfilename, UFDBfileSuffix );

   if (stat( fullfilename, &Stat0 ) != 0)
   {
      Stat0.st_mtime = 0;
      ufdbLogMessage( "category %s: pre-execdomainlist: domainlist does not exist (%s)", cat->name, fullfilename );
   }

   /* The script that we will call needs the directory where the files reside,
    * so we set the environment variable UFDB_TABLEDIR for it to change its working directory.
    * (note that we are multithreaded and cannot use chdir() here)
    */
   strcpy( command, "cd " );
   strcat( command, basefilename );
   t = strrchr( command, '/' );
   if (t != NULL)
      *t = '\0';
   strcat( command, " ; " );
   strcat( command, cat->execdomainlist );

   errno = 0;
   if ((fp = popen(command,"r")) == NULL)
   {
      ufdbLogFatalError( "category %s: can't execute command of execdomainlist \"%s\": popen failed: %s  *****", 
                         cat->name, cat->execdomainlist, strerror(errno) );
      return NULL;
   }

   while (UFDBfgetsNoNL(line,sizeof(line),fp) != NULL)
   {
      ufdbLogMessage( "execdomainlist for %s produced: %s", cat->name, line );
   }
   errno = 0;
   exitcode = pclose( fp );

   if (exitcode == -1  &&  errno == ECHILD)
      exitcode = 0;
      /* most likely the child handler thread already did a wait() */

   if (exitcode == 0)
   {
      if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
         ufdbLogMessage( "   execdomainlist for %s: exit 0 (OK)", cat->name );
   }
   else if (exitcode == -1)
   {
      ufdbLogError( "execdomainlist for %s: pclose error: %d (%s)", cat->name, errno, strerror(errno) );
      return NULL;
   }
   else if (exitcode > 0)
   {
      ufdbLogError( "execdomainlist for %s: command (%s) terminated with an error exit code %d", 
                    cat->name, cat->execdomainlist, exitcode );
      return NULL;
   }

   /* The command defined by 'execdomainlist' has been executed and the exit code was 0 (OK), so
    * now it is verified if the file timestamp of domains.ufdb is newer.
    */

   if (stat( fullfilename, &Stat1 ) != 0)
   {
      ufdbLogError( "execdomainlist for %s: command failed to produce a .ufdb file (%s)", cat->name, fullfilename );
      return NULL;
   }

   newdb = (struct sgDb *) ufdbCalloc( sizeof(struct sgDb), 1 );
   newdb->dbhome = NULL;
   newdb->dbcp = NULL;
   newdb->type = SGDBTYPE_DOMAINLIST;

   sgDbInit( newdb, basefilename );
   if (newdb->dbcp == NULL)
   {
      ufdbLogError( "execdomainlist for %s: command produced a .ufdb file but I failed to load it", cat->name );
      ufdbFree( newdb );
      return NULL;
   }

   if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
      ufdbLogMessage( "execdomainlist for %s: new URL table is loaded", cat->name );

   return newdb;
}


void ufdbSourceExecUserList(
   char *          command )
{
   time_t          t0, te;
   struct Source * sp;

   /* execuserlist is used to dynamically retrieve a list of usernames and
    * is executed every 15 minutes to refresh the list of usernames.
    */

   sp = lastSource;
   if (sp->userDb != NULL  &&  sp->userDb->type != SGDBTYPE_EXECUSERLIST)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         command, sp->name, lineno );
      return;
   }
   if (sp->userDb != NULL)
   {
      ufdbLogFatalError( "execuserlist \"%s\" in source \"%s\" on line %d: "
                         "more than one execuserlist is not supported.  Merge the userlists in the script.", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execuserlist \"%s\"", command );

   t0 = time( NULL );
   sp->userDb = UFDBretrieveExecUserlist( command );
   sp->sarg0 = command;				/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 4)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"  *****", te - t0, command );
 
   if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
   {
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) sp->userDb->dbcp );
   }
}


void ufdbSourceExecIPList(
   char *          command )
{
   time_t          t0, te;
   struct Source * sp;

   /* execiplist is used to dynamically retrieve a list of IP addresses and
    * is executed every 15 minutes to refresh the list of IP addresses.
    */

   sp = lastSource;
   if (sp->ipv4 != NULL  ||  sp->ipv6 != NULL)
   {
      ufdbLogFatalError( "execiplist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec iplists", 
                         command, sp->name, lineno );
      return;
   }
   ufdbLogMessage( "execiplist \"%s\"", command );

   t0 = time( NULL );
   UFDBretrieveExecIPlist( command, &sp->ipv4hosts, &sp->ipv4, &sp->ipv6hosts, &sp->ipv6 );
   sp->execiplistCommand = command;			/* command is already malloc-ed */
   te = time( NULL );

   if (te - t0 > 4)
      ufdbLogMessage( "WARNING: it took %ld seconds to execute \"%s\"  *****", te - t0, command );
 
#if 0
   if (UFDBglobalDebug || UFDBglobalDebugExternalScripts)
   {
      UFDBlogIPv4( sp->ipv4 );
      UFDBlogIPv6( sp->ipv6 );
   }
#endif
}


void ufdbSourceUserList( 
   char * file  )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * s;
   char * lc;
   char * lineptr;
   int    ullineno;
   struct sgDb * udb;
   struct Source * sp;
   char   line[10000];
 
   sp = lastSource;
   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbSourceUserList: source \"%s\"  file \"%s\"", 
       		      sp->name != NULL ? sp->name : "nosource", file );
   udb = sp->userDb;
   if (udb != NULL  &&  udb->type != SGDBTYPE_USERLIST)
   {
      ufdbLogFatalError( "userlist \"%s\" in source \"%s\" on line %d: "
                         "found mix of exec and non-exec userlists", 
                         file, sp->name, lineno );
      return;
   }
   if (udb == NULL)
   {
      udb = sp->userDb = (struct sgDb *) ufdbMalloc( sizeof(struct sgDb) );
      udb->dbhome = NULL;
      udb->dbcp = (void *) UFDBmemDBinit();
      udb->type = SGDBTYPE_USERLIST;
      udb->entries = 0;
   }
 
   dbhome = ufdbSettingGetValue( "dbhome" );
   if (dbhome == NULL)
      dbhome = (char *) DEFAULT_DBHOME;
 
   if (file[0] == '/')
      f = file;
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }
 
   if ((fp = fopen(f,"r")) == NULL)
   {
      ufdbLogError( "line %d: can't open userlist %s: %s  *****", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }
   ullineno = 0;
 
   ufdbLogMessage( "userlist \"%s\"", f );
 
   while (fgets(line,sizeof(line),fp) != NULL)
   {
      ullineno++;
      if (line[0] == '#')			/* skip comments */
         continue;
 
      p = strchr( line, '\n' );
      if (p != NULL)
      {
         *p = '\0';
         if (p != line) 
         {
  	    if (*(p - 1) == '\r') 		/* remove ^M  */
  	       *(p-1) = '\0';
         }
      }
  
      if (line[0] == '\0')
      {
         ufdbLogError( "userlist %s: line %d: line is empty", f, ullineno );
         continue;
      }
  
      c = strchr( line, '#' );		/* remove comment */
      if (c != NULL)
         *c = '\0';
  
      p = strtok_r( line, " \t,", &lineptr );
      if (p == NULL  ||  *p == '\0')
         continue;
  
      /* we may have a passwd-style formatted file. Ignore ':' and everything else that follows. */
      if ((s = strchr(p,':')) != NULL) 
         *s = '\0';
  
      do
      {
         for (lc = p;  *lc != '\0';  lc++)   /* convert username to lowercase chars */
         {
  	    if (*lc <= 'Z'  &&  *lc >= 'A')
  	       *lc += 'a' - 'A';
         }
         if (*p != '\0')
 	 {
	    udb->entries++;
  	    UFDBmemDBinsert( (struct UFDBmemDB *) udb->dbcp, p, NULL );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL  &&  *p != '\0');
   }
   fclose( fp );

   if (UFDBglobalDebug)
   {
      ufdbLogMessage( "just read userlist \"%s\"", f );
      UFDBmemDBprintUserDB( "user", (struct UFDBmemDB *) udb->dbcp );
   }

   ufdbFree( f );
}


static void ufdbSourceUserQuota( 
   const char * seconds, 
   const char * sporadic,  
   const char * renew )
{
   ufdbLogError( "line %d: userquota is not supported", lineno );
}


void defSourceDomain( 
   char * domain )
{
   struct Source * sp;

   sp = lastSource;
   if (sp->domainDb == NULL) 
      sp->domainDb = (struct sgDb *) UFDBmemDBinit();

   if (UFDBglobalDebug)
      ufdbLogMessage( "defSourceDomain \"%s\"", domain );

   UFDBmemDBinsert( (struct UFDBmemDB *) sp->domainDb, domain, NULL );

   ufdbFree( domain );
}


void ufdbSourceEval( 
   int method  )
{
   if (lastSource != NULL)
   {
      if (UFDBglobalDebug)
         ufdbLogMessage( "ufdbSourceEval %d: %s", method, 
	                 method == UFDB_EVAL_OR ? "evaluate-or" : "evaluate-and" );
      lastSource->evaluationMethod = method;
   }
}


static void defSourceTime( 
   char *         name, 
   int            within )
{
   struct ufdbTime *  t;

   if ((t = sgTimeFindName(name)) == NULL)
   {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( name );
      return;
   }

   lastSource->within = within;
   lastSource->time = t;
   ufdbFree( name );
}


struct Source * defSourceFindName( 
   const char *    name )
{
   struct Source * p;

   for (p = UFDBgetSourceList();  p != NULL;  p = p->next)
   {
      if (strcmp(name,p->name) == 0)
         return p;
   }

   return NULL;
}


void defSourceIPV4List( 
   char * file )
{
   char * dbhome = NULL;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   char * cidr;
   int    i;
   int    l = 0;
   char * lineptr;
   char   line[UFDB_MAX_URL_LENGTH];

   dbhome = ufdbSettingGetValue( "dbhome" );
   if (dbhome == NULL)
      dbhome = (char *) DEFAULT_DBHOME;

   if (file[0] == '/') 
   {
      f = file;
   }
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }

   if ((fp = fopen(f,"r")) == NULL) 
   {
      ufdbLogError( "line %d: can't open ipv4list %s: %s", lineno, f, strerror(errno) );
      ufdbFree( f );
     return;
   }

   ufdbLogMessage( "ipv4list \"%s\"", f );

   while (fgets(line,sizeof(line),fp) != NULL)
   {
      l++;
      if (*line == '#')
         continue;
      p = strchr( line, '\n' );
      if (p != NULL && p != line) 
      {
         if (*(p - 1) == '\r') 		/* removing ^M  */
            p--;
         *p = '\0';
      }
      c = strchr( line, '#' );
      p = strtok_r( line, " \t,", &lineptr );
      do {
         if (c != NULL && p >= c) 		/* find the comment */
            break;
         i = strspn( p, ".0123456789/-" );
         if (i == 0)
            break;
         *(p + i) = '\0';
         if ((cidr = strchr(p,'/')) != NULL) 
         {
            *cidr = '\0';
            cidr++;
            if (strchr(cidr,'.') == NULL)
               sgIpv4( p, SG_IPTYPE_CIDR, f, l );
            else 
               sgIpv4( p, SG_IPTYPE_CLASS, f, l );
          }
          else if ((cidr = strchr(p,'-')) != NULL) 
          {
             sgIpv4( p, SG_IPTYPE_RANGE, f, l );
          }
          else
          {
             sgIpv4( p, SG_IPTYPE_HOST, f, l );
          }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
   }

   fclose( fp );
   ufdbFree( f );
}


void defSourceIPV6List( 
   char * file )
{
   char * dbhome;
   char * f;
   FILE * fp;
   char * p;
   char * c;
   int    i;
   int    l = 0;
   char * lineptr;
   char   line[UFDB_MAX_URL_LENGTH];

   dbhome = ufdbSettingGetValue( "dbhome" );
   if (dbhome == NULL)
      dbhome = (char *) DEFAULT_DBHOME;

   if (file[0] == '/') 
   {
      f = file;
   }
   else
   {
      f = (char *) ufdbMalloc( strlen(dbhome) + strlen(file) + 2 );
      strcpy( f, dbhome );
      strcat( f, "/" );
      strcat( f, file );
      ufdbFree( file );
   }

   if ((fp = fopen(f,"r")) == NULL) 
   {
      ufdbLogError( "line %d: can't open ipv6list %s: %s", lineno, f, strerror(errno) );
      ufdbFree( f );
      return;
   }

   ufdbLogMessage( "ipv6list \"%s\"", f );

   while (fgets(line,sizeof(line),fp) != NULL)
   {
      l++;
      if (*line == '#')
         continue;
      p = strchr( line, '\n' );
      if (p != NULL && p != line) 
      {
         if (*(p - 1) == '\r') 		/* removing ^M  */
            p--;
         *p = '\0';
      }
      c = strchr( line, '#' );
      p = strtok_r( line, " \t,", &lineptr );
      do {
         if (c != NULL && p >= c) 		/* find the comment */
            break;
         i = strspn( p, ":.0123456789ABCDEFabcdef/" );
         if (i == 0)
            break;
         *(p + i) = '\0';
         if (strchr(p,'/') != NULL) 
         {
            sgIpv6( p, SG_IPV6TYPE_CIDR, f, l );
         }
         else
         {
            sgIpv6( p, SG_IPV6TYPE_HOST, f, l );
         }
      } while ((p = strtok_r(NULL," \t,",&lineptr)) != NULL);
   }

   fclose( fp );
   ufdbFree( f );
}


/* category block functions */

void ufdbCategory( 
  char *            cat )
{
  struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategory %s", cat );
#endif

  if (Cat != NULL) 
  {
    if ((struct Category *) ufdbCategoryFindName(cat) != NULL)
    {
      ufdbLogFatalError( "line %d: category %s is already defined in configuration file %s",
		         lineno, cat, UFDBglobalConfigFile );
      ufdbFree( cat );
      return;
    }
  }

  sp = (struct Category *) ufdbMallocAligned( 64, sizeof(struct Category) );
  sp->active = 1;
  sp->within = UFDB_ACL_NONE;
  sp->activeBumping = UFDB_ACTIVE_BUMPING_NOTSET;
  sp->blockBumpedConnect = 0;
  sp->options = 0;
  sp->name = cat;
  sp->domainlist = NULL;
  sp->domainlistDb = NULL;
  sp->execdomainlist = NULL;
  sp->expressionlist = NULL;
  sp->regExp = NULL;
  sp->redirect = NULL;
  sp->time = NULL;
  sp->rewrite = NULL;
  sp->cse = NULL;
  sp->cse2 = NULL;
  sp->next = NULL;
  sp->nblocks = 0;
  sp->nmatches = 0;

  if (Cat == NULL) {
    Cat = sp;
    lastCat = sp;
  } else {
    lastCat->next = sp;
    lastCat = sp;
  }

   /* category "security" is a special case: the options cannot be set default to 0
    * because the default value for allow-unknown-protocol-over-https is ON.
    */
   if (strcmp( cat, "security" ) == 0)
      sp->options = UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS;
}


void ufdbCategoryEnd( void )
{
  struct Category * d;
 
  d = lastCat;
  if (d->domainlist == NULL  &&  d->expressionlist == NULL  && 
      d->redirect == NULL  &&  d->rewrite == NULL  &&
      d->options == 0)
  {
    ufdbLogError( "category \"%s\" is missing content, set inactive  *****", d->name );
    d->time = NULL;
    d->active = 0;
  }
}


void ufdbCategoryOption( int value, int option )
{
   struct Category * sp;

   sp = lastCat;
   if (value)
      sp->options = sp->options | option;
   else
      sp->options = sp->options & (~option);

   if (option == UFDB_OPT_HTTPS_WITH_HOSTNAME)
      UFDBglobalHttpsWithHostname = value;
   else if (option == UFDB_OPT_HTTPS_OFFICAL_CERTIFICATE)
      UFDBglobalHttpsOfficialCertificate = value;
   else if (option == UFDB_OPT_SKYPE_OVER_HTTPS)
      UFDBglobalSkypeOverHttps = value;
   else if (option == UFDB_OPT_GTALK_OVER_HTTPS)
      UFDBglobalGtalkOverHttps = value;
   else if (option == UFDB_OPT_YAHOOMSG_OVER_HTTPS)
      UFDBglobalYahooMsgOverHttps = value;
   else if (option == UFDB_OPT_AIM_OVER_HTTPS)
      UFDBglobalAimOverHttps = value;
   else if (option == UFDB_OPT_FBCHAT_OVER_HTTPS)
      UFDBglobalFBchatOverHttps = value;
   else if (option == UFDB_OPT_CITRIXONLINE_OVER_HTTPS)
      UFDBglobalCitrixOnlineOverHttps = value;
   else if (option == UFDB_OPT_ANYDESK_OVER_HTTPS)
      UFDBglobalAnydeskOverHttps = value;
   else if (option == UFDB_OPT_TEAMVIEWER_OVER_HTTPS)
      UFDBglobalTeamviewerOverHttps = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV2)
      UFDBglobalHttpsNoSSLv2 = value;
   else if (option == UFDB_OPT_PROHIBIT_INSECURE_SSLV3)
      UFDBglobalHttpsNoSSLv3 = value;
   else if (option == UFDB_OPT_UNKNOWN_PROTOCOL_OVER_HTTPS)
      UFDBglobalUnknownProtocolOverHttps = value;
   else if (option == UFDB_OPT_SAFE_SEARCH)
      ;
   else if (option == UFDB_OPT_YOUTUBE_EDUFILTER)
      ;
   else
      ufdbLogError( "ufdbCategoryOption: unrecognised option %d *****", option );

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbCategoryOption: %s: option %d set to %d", sp->name, option, value );
}


void ufdbCategoryDomainList( 
  char * domainlist )
{
  struct Category * sp;
  const char *      dbhome;
        char *      dl = domainlist;
  const char *      name;

  if (UFDBglobalDebug > 1)
     ufdbLogMessage( "ufdbCategoryDomainList %s", domainlist );

  if (UFDBglobalTerminating)
     return;

  sp = lastCat;

  if (sp->domainlistDb != NULL)
  {
     ufdbLogFatalError( "line %d: specify only one domainlist per category in configuration file %s",
		        lineno, UFDBglobalConfigFile );
     return;
  }

  dbhome = ufdbSettingGetValue("dbhome");
  if (dbhome == NULL)
    dbhome = DEFAULT_DBHOME;

  if (domainlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/domainlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/domainlist");

    sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->domainlist,dbhome);
    strcat(sp->domainlist,"/");
    strcat(sp->domainlist,dl);
  }
  else
  {
    if (domainlist[0] == '/') 
      sp->domainlist = domainlist;
    else
    {
       sp->domainlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(domainlist) + 2 );
       strcpy( sp->domainlist, dbhome );
       strcat( sp->domainlist, "/" );
       strcat( sp->domainlist, domainlist );
       ufdbFree( (void*) domainlist );
    }
  }

  sp->domainlistDb = (struct sgDb *) ufdbCalloc( 1, sizeof(struct sgDb) );
  sp->domainlistDb->type = SGDBTYPE_DOMAINLIST;
  sgDbInit( sp->domainlistDb, sp->domainlist );
  ufdbLogMessage( "loading URL table from \"%s\"", sp->domainlist );
  if (sp->domainlistDb->dbcp == NULL  ||
      ((struct UFDBmemTable *) sp->domainlistDb->dbcp)->table.nNextLevels == 0)
  {
    ufdbLogError( "URL database table \"%s\" is empty and is ignored   *****", sp->domainlist );
    ufdbFreeDomainDb( sp->domainlistDb );
    sp->domainlistDb = NULL;
  }
}


void ufdbCategoryExecDomainList( 
   char * command )
{
   struct Category * sp;

   if (UFDBglobalTerminating)
      return;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExecDomainList %s", command );
#endif

   sp = lastCat;

   if (sp == NULL)
   {
      ufdbLogFatalError( "execdomainlist is not within a URL category" );
      return;
   }
   sp->execdomainlist = command;

   if (UFDBglobalDebug)
      ufdbLogMessage( "execdomainlist for category %s: \"%s\"", sp->name, command );
}


void ufdbFreeDomainDb( 
   struct sgDb * dbp )
{
   struct UFDBmemTable * mt;

   if (dbp == NULL)
      return;

   mt = (struct UFDBmemTable *) dbp->dbcp;
   if (UFDBglobalDebug > 2)
      ufdbLogMessage( "ufdbFreeDomainDb:  mt %08lx  index %08lx  nextlevel %08lx",
                      (unsigned long) mt,
		      mt==NULL ? 0L : (unsigned long) mt->index,
		      mt==NULL ? 0L : (unsigned long) mt->table.nextLevel );
   if (mt != NULL)
   {
      if (mt->index != NULL)
      {
	 ufdbFree( mt->index );				/* version 2.x */
	 ufdbFree( mt->table.nextLevel );
      }
      else
	 UFDBfreeTableIndex_1_2( &(mt->table) ); 	/* version 1.2 */
      ufdbFree( (void *) mt->mem );
      ufdbFree( mt );
   }
   ufdbFree( dbp );
}


void ufdbFreeIpv4List( struct Ipv4 * ipv4 )
{
   struct Ipv4 * tmp;

   while (ipv4 != NULL)
   {
      tmp = ipv4->next;
      ufdbFree( (void*) ipv4 );
      ipv4 = tmp;
   }
}


void ufdbFreeIpv6List( struct Ipv6 * ipv6 )
{
   struct Ipv6 * tmp;

   while (ipv6 != NULL)
   {
      tmp = ipv6->next;
      ufdbFree( (void*) ipv6 );
      ipv6 = tmp;
   }
}


void ufdbFreeSourceList( struct Source * src )
{
   struct Source * tmp;

   while (src != NULL)
   {
      if (src->ipv4hosts != NULL)
         UFDBmemDBdeleteDB( src->ipv4hosts );
      ufdbFreeIpv4List( src->ipv4 );
      if (src->ipv6hosts != NULL)
         UFDBmemDBdeleteDB( src->ipv6hosts );
      ufdbFreeIpv6List( src->ipv6 );

      ufdbFree( (void*) src->name );
      if (src->domainDb != NULL)
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) src->domainDb );

      /* execuserlist content is saved during a reload */
      if (src->userDb != NULL  &&  src->userDb->type != SGDBTYPE_EXECUSERLIST)
      {
	 UFDBmemDBdeleteDB( (struct UFDBmemDB *) src->userDb->dbcp );
	 ufdbFree( (void*) src->userDb );
      }
      ufdbFree( (void*) src->sarg0 );
      ufdbFree( (void*) src->execiplistCommand );

      tmp = src->next;
      ufdbFree( (void*) src );
      src = tmp;
   }
}


void ufdbFreeAclCategoryList( struct AclCategory * ac )
{
   struct AclCategory * tmp;

   while (ac != NULL)
   {
      ufdbFree( (void*) ac->name );
      tmp = ac->next;
      ufdbFree( (void*) ac );
      ac = tmp;
   }
}


void ufdbFreeAclList( struct Acl * acl )
{
   struct Acl * tmp;

   while (acl != NULL)
   {
      ufdbFree( (void*) acl->name );
      ufdbFreeAclCategoryList( acl->pass );
      ufdbFreeAclCategoryList( acl->implicitPass );
      ufdbFree( (void*) acl->redirect );
      tmp = acl->next;
      ufdbFree( (void*) acl );
      acl = tmp;
   }
}


void ufdbFreeSettingList( struct ufdbSetting * p )
{
   struct ufdbSetting * tmp;
 
   while (p != NULL)
   {
      ufdbFree( (void*) p->name );
      ufdbFree( (void*) p->value );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


static void ufdbFreeCategoryList( struct Category * cat )
{
   struct Category * tmp;

   while (cat != NULL)
   {
      if (UFDBglobalDebug > 2  ||  UFDBglobalDebugRegexp)
         ufdbLogMessage( "ufdbFreeCategoryList: freeing regexp of category %s", cat->name );
      ufdbFreeRegExprList( cat->regExp );
      ufdbFree( (void*) cat->name );
      ufdbFree( (void*) cat->domainlist );
      ufdbFreeDomainDb( cat->domainlistDb );
      ufdbFree( (void*) cat->execdomainlist );
      ufdbFree( (void*) cat->cse );
      ufdbFree( (void*) cat->cse2 );
      ufdbFree( (void*) cat->expressionlist );
      ufdbFree( (void*) cat->redirect );
      /* ufdbFree( cat->rewrite );  freed in ufdbFreeRewriteList() */
      tmp = cat->next;
      ufdbFree( (void*) cat );
      cat = tmp;
   }
}


void ufdbFreeRewriteList( 
   struct sgRewrite * p )
{
   struct sgRewrite * tmp;

   while (p != NULL)
   {
      ufdbFreeRegExprList( p->rewrite );
      ufdbFree( (void*) p->name );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


void ufdbFreeTimeElement( 
   struct TimeElement * p )
{
   struct TimeElement * tmp;

   while (p != NULL)
   {
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


void ufdbFreeTime( 
   struct ufdbTime * p )
{
   struct ufdbTime * tmp;

   while (p != NULL)
   {
      ufdbFree( (void*) p->name );
      ufdbFreeTimeElement( p->element );
      tmp = p->next;
      ufdbFree( (void*) p );
      p = tmp;
   }
}


void ufdbFreeLastBits( void )
{
   if (UFDBglobalPidFile != NULL)
   {
      ufdbFree( (void*) UFDBglobalPidFile );
      UFDBglobalPidFile = NULL;
   }
   if (UFDBglobalEmailServer != NULL)
   {
      ufdbFree( (void*) UFDBglobalEmailServer );
      UFDBglobalEmailServer = NULL;
   }
   if (UFDBglobalMyHostname != NULL)
   {
      ufdbFree( (void*) UFDBglobalMyHostname );
      UFDBglobalMyHostname = NULL;
   }
   if (UFDBglobalAdminEmail != NULL)
   {
      ufdbFree( (void*) UFDBglobalAdminEmail );
      UFDBglobalAdminEmail = NULL;
   }
   if (UFDBglobalSenderEmail != NULL)
   {
      ufdbFree( (void*) UFDBglobalSenderEmail );
      UFDBglobalSenderEmail = NULL;
   }
   if (UFDBglobalExternalStatusCommand != NULL)
   {
      ufdbFree( (void*) UFDBglobalExternalStatusCommand );
      UFDBglobalExternalStatusCommand = NULL;
   }
   if (UFDBglobalLogDir != NULL)
   {
      ufdbFree( (void*) UFDBglobalLogDir );
      UFDBglobalLogDir = NULL;
   }
}


void ufdbFreeAllMemory( void )
{
#if 0
   /* we cannot stop using the log file. we never close it */
   if (UFDBglobalLogDir != NULL)
      ufdbFree( UFDBglobalLogDir );
   UFDBglobalLogDir = NULL;
#endif

   ufdbFreeSettingList( Setting );
   Setting = NULL;
   lastSetting = NULL;

   ufdbFreeRewriteList( Rewrite );
   Rewrite = NULL;
   lastRewrite = NULL;
   lastRewriteRegExec = NULL;

   ufdbFreeCategoryList( Cat );
   Cat = NULL;
   lastCat = NULL;

   ufdbFreeAclList( AclList );
   AclList = NULL;
   lastAcl = NULL;
   defaultAcl = NULL;
   lastAclCategory = NULL;

   ufdbFreeSourceList( (struct Source *) SourceList );
   UFDBsetSourceList( NULL );
   lastSource = NULL;

   /* free UFDBglobalCheckedDB */
   if (UFDBglobalCheckedDB.mem != NULL)
   {
      if (UFDBglobalCheckedDB.index != NULL)
      {
         ufdbFree( (void*) UFDBglobalCheckedDB.index );
	 ufdbFree( UFDBglobalCheckedDB.table.nextLevel );
      }
      else
	 UFDBfreeTableIndex_1_2( &(UFDBglobalCheckedDB.table) );
      ufdbFree( (void*) UFDBglobalCheckedDB.mem );
   }
   UFDBglobalCheckedDB.table.nextLevel = NULL;
   UFDBglobalCheckedDB.table.nNextLevels = 0;
   UFDBglobalCheckedDB.mem = NULL;
   UFDBglobalCheckedDB.index = NULL;

   if (UFDBglobalCheckedExpressions != NULL)
   {
      ufdbFreeRegExprList( UFDBglobalCheckedExpressions );
      UFDBglobalCheckedExpressions = NULL;
   }

   ufdbFreeTime( TimeList );
   TimeList = NULL;
   lastTime = NULL;

   ufdbFree( TimeElementsEvents );
   TimeElementsEvents = NULL;
   numTimeElements = 0;

   lastTimeElement = NULL;
   TimeElement = NULL;

   lastRegExpDest = NULL;

   ufdbFree( (void*) UFDBglobalSquidVersion );
   UFDBglobalSquidVersion = NULL;
}


void ufdbCategoryUrlList( 
   char * urllist )
{
   if (urllist == NULL)
      urllist = (char *) "-";
   ufdbLogError( "line %d: \"urllist %s\" is deprecated and ignored *****\n"
                 "ufdbGenTable should be called with the -u option to include URLs\n"
		 "ufdbGenTable combines URLs and domains in one table file so only the domainlist is required",
		 lineno, urllist );
   if (urllist[0] != '-')
      ufdbFree( (void*) urllist );
}


void ufdbCategoryExpressionList( 
  char * exprlist, 
  const char * chcase  )
{
  FILE * fp;
  char * dbhome;
  char * dl;
  const char * name;
  char * p;
  int    flags;
  struct stat         statbuf;
  struct Category *   sp;
  struct ufdbRegExp * regexp;
  char   buf[UFDB_MAX_URL_LENGTH];
  char   errbuf[256];

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryExpressionList %s", exprlist );
#endif

  if (UFDBglobalTerminating)
     return;

  flags = REG_EXTENDED | REG_NOSUB;
  dbhome = ufdbSettingGetValue( "dbhome" );
  sp = lastCat;
  if (dbhome == NULL)
    dbhome = (char *) DEFAULT_DBHOME;

  if (exprlist == NULL)
  {
    name = sp->name;
    dl = (char *) ufdbMalloc( sizeof("/dest/") + strlen(name) + sizeof("/expressionlist") + 2 );
    strcpy(dl,"/dest/");
    strcat(dl,name);
    strcat(dl,"/expressionlist");

    flags |= REG_ICASE; 	/* default case insensitive */

    sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(dl) + 2 );
    strcpy(sp->expressionlist,dbhome);
    strcat(sp->expressionlist,"/");
    strcat(sp->expressionlist,dl);
  }
  else
  {
    if (exprlist[0] == '/') 
    {
      sp->expressionlist = exprlist;
    }
    else
    {
       sp->expressionlist = (char *) ufdbMalloc( strlen(dbhome) + strlen(exprlist) + 2 );
       strcpy( sp->expressionlist, dbhome );
       strcat( sp->expressionlist, "/" );
       strcat( sp->expressionlist, exprlist );
       ufdbFree( (void*) exprlist );
    }
    if (*chcase == 'i')
       flags |= REG_ICASE;     /* set case insensitive */
  }

  ufdbLogMessage( "loading regular expressions from \"%s\"", sp->expressionlist );

  if ((fp = fopen(sp->expressionlist, "r")) == NULL) 
  {
    ufdbLogFatalError( "cannot open expression list %s: %s", sp->expressionlist, strerror(errno) );
    return;
  }

  if (0 == fstat( fileno(fp), &statbuf ))
  {
     if (!S_ISREG(statbuf.st_mode))
     {
        ufdbLogFatalError( "expression list %s: not a regular file", sp->expressionlist );
	fclose( fp );
	return;
     }
  }

  while (!feof(fp)  &&  fgets(buf, sizeof(buf), fp) != NULL) 
  {
    if (buf[0] == '#')
       continue;

    p = (char *) strchr( buf, '\n' );
    if (p != NULL  &&  p != buf) 
    {
      if (*(p-1) == '\r') 	/* removing ^M  */
	p--;
      *p = '\0';
    }
    /* TO-DO: warn about leading and trailing spaces */
    regexp = ufdbNewPatternBuffer( buf, flags );
    if (regexp->error) 
    {
      regerror( regexp->error, (regex_t*) regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "regular expression error in %s:\n%s : %s   *****", sp->expressionlist, errbuf, buf );
    }
    if (lastCat->regExp == NULL) 
    {
      lastCat->regExp = regexp;
      lastRegExpDest = regexp;
    }
    else
    {
      lastRegExpDest->next = regexp;
      lastRegExpDest = regexp;
    }
  }

  fclose( fp );

  if (UFDBglobalExpressionOptimisation)
     lastCat->regExp = UFDBoptimizeExprList( sp->expressionlist, lastCat->regExp );
}


void ufdbCategoryCACertsFile(
   char *              cacertsFile )
{
   struct Category *   cat;

   cat = lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts can only be defined inside the \"security\" category" );
      return;
   }

   cat->cse = cacertsFile;
   if (*cacertsFile == '/')
      strcpy( UFDBglobalCAcertsFile, cacertsFile );
   else
   {
      char * dbh;
      dbh = ufdbSettingGetValue( "dbhome" );
      if (dbh == NULL)
         dbh = (char *) DEFAULT_DBHOME;
      strcpy( UFDBglobalCAcertsFile, dbh );
      strcat( UFDBglobalCAcertsFile, "/" );
      strcat( UFDBglobalCAcertsFile, cacertsFile );
   }
}


void ufdbCategoryCACertsDir(
   char *              cacertsDir )
{
   struct Category *   cat;

   cat = lastCat;
   if (cat == NULL  ||  strcmp( cat->name, "security" ) != 0)
   {
      ufdbLogFatalError( "cacerts-dir can only be defined inside the \"security\" category" );
      return;
   }

   cat->cse2 = cacertsDir;
   if (*cacertsDir == '/')
      strcpy( UFDBglobalCAcertsDir, cacertsDir );
   else
   {
      char * dbh;
      dbh = ufdbSettingGetValue( "dbhome" );
      if (dbh == NULL)
        dbh = (char *) DEFAULT_DBHOME;
      strcpy( UFDBglobalCAcertsDir, dbh );
      strcat( UFDBglobalCAcertsDir, "/" );
      strcat( UFDBglobalCAcertsDir, cacertsDir );
   }
}


void ufdbCategoryRedirect( 
   char * value )
{
   struct Category * sp;

#if UFDB_DEBUG
   ufdbLogMessage( "ufdbCategoryRedirect %s", value );
#endif

   sp = lastCat;
   sp->redirect = value;
   /* TODO: check that "localhost" is not here if no 302 is used */
}


void ufdbCategoryRewrite( 
  char *              value )
{
  struct sgRewrite *  rewrite;

  if ((rewrite = sgRewriteFindName(value)) == NULL)
  {
    ufdbLogFatalError( "line %d: rewrite %s is not defined in configuration file %s",
		       lineno, value, UFDBglobalConfigFile );
    return;
  }

  lastCat->rewrite = rewrite;
}


void ufdbCategoryBlockConnect( 
   int flag  )
{
   lastCat->blockBumpedConnect = flag;

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbCategoryBlockConnect: category \"%s\" : block-bumped-connect %s",
                      lastCat->name, flag ? "on" : "off" );
}


void ufdbCategoryActiveBumping( 
   int flag  )
{
   lastCat->activeBumping = flag ? UFDB_ACTIVE_BUMPING_ON : UFDB_ACTIVE_BUMPING_OFF;

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbCategoryActiveBumping: category \"%s\" : squid-uses-active-bumping %s",
                      lastCat->name, flag ? "on" : "off" );
}


void ufdbCategoryTime(  
  char *        name, 
  int  		within )
{
  struct ufdbTime * t;

  if ((t = sgTimeFindName(name)) == NULL) 
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, UFDBglobalConfigFile );
    ufdbFree( (void*) name );
    return;
  }

  lastCat->within = within;
  lastCat->time = t;
  ufdbFree( (void*) name );
}


struct Category * ufdbCategoryFindName( 
  const char *      name )
{
  struct Category * p;

  for (p = Cat; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


void sgRewrite( 
  char * rewrite )
{
  struct sgRewrite * rew;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewrite %s", rewrite );
#endif

  if (Rewrite != NULL)
  {
    if ((struct sgRewrite *) sgRewriteFindName(rewrite) != NULL)
    {
      ufdbLogFatalError( "line %d: rewrite \"%s\" is not defined in configuration file %s",
		       lineno, rewrite, UFDBglobalConfigFile );
      ufdbFree( (void*) rewrite );
      return;
    }
  }

  rew = (struct sgRewrite *) ufdbMalloc( sizeof(struct sgRewrite) );
  rew->name = rewrite;
  rew->active = 1;
  rew->rewrite = NULL;
  rew->time = NULL;
  rew->within = UFDB_ACL_NONE;
  rew->next = NULL;

  if (Rewrite == NULL) 
  {
    Rewrite = rew;
    lastRewrite = rew;
  }
  else
  {
    lastRewrite->next = rew;
    lastRewrite = rew;
  }
}


void sgRewriteTime( 
  char * name, 
  int    within )
{
  struct ufdbTime * t;

#if UFDB_DEBUG
   ufdbLogMessage( "sgRewriteTime %s %d", name, within );
#endif

  if ((t = sgTimeFindName(name)) == NULL)
  {
    ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		       lineno, name, UFDBglobalConfigFile );
    ufdbFree( (void*) name );
    return;
  }

  lastRewrite->within = within;
  lastRewrite->time = t;
  ufdbFree( (void*) name );
}


void sgRewriteSubstitute( 
  char * string )
{
  char * pattern; 
  char * subst = NULL;
  char * p;
  int    flags = REG_EXTENDED;
  int    global = 0;
  char * httpcode = NULL;
  struct ufdbRegExp * regexp;
  char   errbuf[256];

  pattern = string + 2; 	/* skipping s@ */
  p = pattern;
  while ((p = strchr(p,'@')) != NULL)
  {
    if (*(p - 1) != '\\') 
    {
      *p = '\0';
      subst = p + 1;
      break;
    }
    p++;
  }

  p = strrchr( subst, '@' );
  while (p != NULL  &&  *p != '\0')
  {
    if (*p == 'r' )
      httpcode =  (char *) REDIRECT_TEMPORARILY;
    if (*p == 'R' )
      httpcode =  (char *) REDIRECT_PERMANENT;
    if (*p == 'i' || *p == 'I')
      flags |= REG_ICASE;
    if (*p == 'g')
      global = 1;
    *p = '\0'; 		/* removes @i from string */
    p++;
  } 

  regexp = ufdbNewPatternBuffer( pattern, flags );
  if (regexp->error) 
  {
      regerror( regexp->error, (regex_t*) regexp->compiled[0], errbuf, sizeof(errbuf) );
      ufdbLogError( "line %d: regular expression error in %s:\n%s   *****", lineno, pattern, errbuf );
  }
  else {
    regexp->substitute = ufdbStrdup( subst );
  }

  if (lastRewrite->rewrite == NULL)
    lastRewrite->rewrite = regexp;
  else 
    lastRewriteRegExec->next = regexp;
  regexp->httpcode = httpcode;
  regexp->global = global;
  lastRewriteRegExec = regexp;
}


struct sgRewrite * sgRewriteFindName( 
  const char * name )
{
  struct sgRewrite * p;

  for (p = Rewrite; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


/*
 * Time functions
 */

/*
 * sgTime - parse configuration time statement.
 */
static void sgTime( 
  char *        name )
{
  struct ufdbTime * t;

  if (UFDBglobalDebug)
     ufdbLogMessage( "sgTime %s", name );

  if (TimeList != NULL)
  {
    if ((struct ufdbTime *) sgTimeFindName(name) != NULL)
    {
      ufdbLogFatalError( "line %d: time \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( (void*) name );
      return;
    }
  }
  else 
    numTimeElements = 0;

  t = (struct ufdbTime *) ufdbMalloc( sizeof(struct ufdbTime) );
  t->name = name;
  t->active = 1;
  t->element = NULL;
  t->next = NULL;

  TimeElement = NULL;
  lastTimeElement = NULL;
  if (TimeList == NULL) 
  {
    TimeList = t;
    lastTime = t;
  }
  else
  {
    lastTime->next = t;
    lastTime = t;
  }
}


/*
 * sgTimeElementInit - initialise parsing of a configuration time element.
 */
static void sgTimeElementInit( void )
{
   struct TimeElement * te;

   te = (struct TimeElement *) ufdbCalloc( 1, sizeof(struct TimeElement) );
   numTimeElements++;

   if (lastTime->element == NULL)
     lastTime->element = te;
   if (lastTimeElement != NULL)
     lastTimeElement->next = te;
   lastTimeElement = te;
}


/*
 * sgTimeElementEnd - finalise parsing of configuration time element.
 */
static void sgTimeElementEnd( void )
{
  time_switch = 0;
  date_switch = 0;

  if (lastTimeElement->fromdate != 0)
  {
    if (lastTimeElement->todate == 0)
      lastTimeElement->todate = lastTimeElement->fromdate + 86399;
    else 
      lastTimeElement->todate = lastTimeElement->todate + 86399;
  }

  if (lastTimeElement->from == 0  &&  lastTimeElement->to == 0)
    lastTimeElement->to = 1439;  /* set time to 23:59 */
}


/*
 * sgTimeElementAdd - add configuration time element.
 */
static void sgTimeElementAdd( 
  char * element, 
  char   type ) 
{
  struct TimeElement * te;
  char * p;
  char   wday;
  int    h, m, Y, M, D;
  time_t sec;
  char * lineptr;

  wday = 0;
  M = 0;
  D = -1;
  te = lastTimeElement;

  switch (type)
  {
  case T_WEEKDAY:
    p = strtok_r( element, " \t,", &lineptr );
    do {
      if (*p == '*') {
	wday = 0x7F;
      } else if (!strncmp(p,"sun",3)) {
	wday = wday | 0x01;
      } else if (!strncmp(p,"mon",3)) {
	wday = wday | 0x02;
      } else if (!strncmp(p,"tue",3)) {
	wday = wday | 0x04;
      } else if (!strncmp(p,"wed",3)) {
	wday = wday | 0x08;
      } else if (!strncmp(p,"thu",3)) {
	wday = wday | 0x10;
      } else if (!strncmp(p,"fri",3)) {
	wday = wday | 0x20;
      } else if (!strncmp(p,"sat",3)) {
	wday = wday | 0x40;
      }
      p = strtok_r( NULL, " \t,", &lineptr );
    } while (p != NULL);
    te->wday = wday;
    break;

  case T_TVAL:
    h = -1;
    m = -1;
    sscanf( element, "%d:%d", &h, &m );
    if ((h < 0 || h > 24) || (m < 0 || m > 59))
    {
      ufdbLogFatalError( "line %d: time format error in %s", lineno, UFDBglobalConfigFile );
      h = 0;
      m = 0;
    }
    if (time_switch == 0) 
    {
      time_switch++;
      te->from = (h * 60) + m ;
    }
    else
    {
      time_switch = 0;
      te->to = (h * 60) + m ;
    }
    break;

  case T_DVAL:
    sec = date2sec( element );
    if (sec == -1) 
    {
      ufdbLogFatalError( "line %d: date format error in %s", lineno, UFDBglobalConfigFile );
      sec = 1;
    }
    if (date_switch == 0) {
      date_switch++;
      te->fromdate = sec;
    } else {
      date_switch = 0;
      te->todate = sec;
    }
    break;

  case T_DVALCRON:
    p = strtok_r( element, "-./", &lineptr );
    Y = atoi(p);
    if (*p == '*')
      Y = -1;
    else
      Y = atoi(p);
    while ((p=strtok_r(NULL,"-./",&lineptr)) != NULL) 
    {
      if (*p == '*')
	if (M == 0)
	  M = -1;
	else 
	  D = -1;
      else
	if (M == 0)
	  M = atoi(p);
	else
	  D = atoi(p);
    }
    te->y = Y;
    te->m = M;
    te->d = D;
    break;

  case T_WEEKLY:
    p = element;
    while (*p != '\0') 
    {
      switch (*p) {
      case 'S':
      case 's':
	wday = wday | 0x01;
	break;
      case 'M':
      case 'm':
	wday = wday | 0x02;
	break;
      case 'T':
      case 't':
	wday = wday | 0x04;
	break;
      case 'W':
      case 'w':
	wday = wday | 0x08;
	break;
      case 'H':
      case 'h':
	wday = wday | 0x10;
	break;
      case 'F':
      case 'f':
	wday = wday | 0x20;
	break;
      case 'A':
      case 'a':
	wday = wday | 0x40;
	break;
      default:
	ufdbLogFatalError( "line %d: weekday format error in %s", lineno, UFDBglobalConfigFile );
	break;
      }
      p++;
    }
    te->wday = wday;
    break;
  }

  ufdbFree( (void*) element );
}


/* 
 * lookup a ufdbTime element by name.
 */
static struct ufdbTime * sgTimeFindName( 
  const char * name )
{
  struct ufdbTime * p;

  for (p = TimeList; p != NULL; p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


/*
 * sgTimeCmp - Time array sort function.
 */
static int sgTimeCmp( const void * a, const void * b )
{
   const int * aa = (const int *) a;
   const int * bb = (const int *) b;

   return *aa - *bb;
}


/*
 * getSortedTimeElementTimes - produce a sorted array of time element times
 */
static void getSortedTimeElementTimes( void )
{
   struct ufdbTime *    p;
   struct TimeElement * te;
   int                  i, j;
   int                  totalNumElems;
 
   if (UFDBglobalDebug)
      ufdbLogMessage( "getSortedTimeElementEvents" );

   if (TimeList == NULL)
      return;

   /* find total number of time elements */
   totalNumElems = 0;
   for (p = TimeList;  p != NULL;  p = p->next) 
      for (te = p->element;  te != NULL;  te = te->next) 
         totalNumElems++;

   TimeElementsEvents = (int *) ufdbCalloc( totalNumElems * 2 , sizeof(int) ); 

   i = 0;
   for (p = TimeList;  p != NULL;  p = p->next) 
   {
      for (te = p->element;  te != NULL;  te = te->next) 
      {
         TimeElementsEvents[i++] = te->from == 0 ? 1440 : te->from;
         TimeElementsEvents[i++] = te->to == 0   ? 1440 : te->to;
      }
   }
 
   qsort( TimeElementsEvents, totalNumElems * 2, sizeof(int), sgTimeCmp );

   if (UFDBglobalDebug)
      ufdbLogMessage( "   getSortedTimeElementEvents: after qsort" );

   /* remove identical time elements */
   for (i=1,j=1;  i < totalNumElems * 2;  i++) 
   {
      if (TimeElementsEvents[i] > TimeElementsEvents[i-1])
      {
	 TimeElementsEvents[j] = TimeElementsEvents[i];
         j++;
      }
   }

   numTimeElements = j;			/* #unique time elements */
}


/*
 * _TimeEvaluateElements - evaluate all elements if they match the current time/date and mark them active.
 */
static void _TimeEvaluateElements( 
  struct tm * tm_now, 
  time_t      now )
{
  struct ufdbTime *    tlist;
  struct TimeElement * te;
  int                  min;

  if (UFDBglobalDebug)
     ufdbLogMessage( "_TimeEvaluateElements" );

  for (tlist = TimeList;  tlist != NULL;  tlist = tlist->next)
  {
    tlist->active = 0;
    for (te = tlist->element;  te != NULL;  te = te->next)
    {
      if (te->wday != 0) 			/* check wday */
      {
	if (((1 << tm_now->tm_wday) & te->wday) != 0)  
	{
	  min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else if (te->fromdate != 0)		/* check date */
      {
	if (now >= te->fromdate  &&  now <= te->todate) 
	{
	  min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	  if (min >= te->from  &&  min < te->to) 
	  {
	    tlist->active = 1;
	    break;
	  }
	}
      }
      else					/* check crondate */
      {
	if (te->y == -1  ||  te->y == (tm_now->tm_year + 1900)) 
	{
	  if (te->m == -1  ||  te->m == (tm_now->tm_mon + 1)) 
	  {
	    if (te->d == -1  ||  te->d == (tm_now->tm_mday)) 
	    {
	      min = (tm_now->tm_hour * 60 ) + tm_now->tm_min;
	      if (min >= te->from  &&  min < te->to) 
	      {
		tlist->active = 1;
		break;
	      }
	    }
	  }
	}
      }
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeEvaluateElements: time %s is %sactive", tlist->name, tlist->active?"":"not " );
  }
}


/*
 * _TimeSetAclSrcDestRew - mark all acl/source/dest/rew (in)active.
 */
static void _TimeSetAclSrcDestRew( void )
{
  struct Acl *         acl;
  struct Category *    cat;
  struct Source *      s;
  struct sgRewrite *   rew;
  int                  a;

  if (UFDBglobalDebug)
     ufdbLogMessage( "_TimeSetAclSrcDestRew" );

  for (acl = AclList;  acl != NULL;  acl = acl->next)
  {
    if (acl->time != NULL  &&  acl->within != UFDB_ACL_ELSE) 
    {
      /* Be careful here: we are multithreaded and other threads use the value 
       * of acl->active at the same time.
       */
      a = acl->time->active;
      if (acl->within == UFDB_ACL_OUTSIDE)
	a = !a;
      if (acl->next != NULL  &&  acl->next->within == UFDB_ACL_ELSE) 
	acl->next->active = !a;
      acl->active = a;
    }
#if 0
    if (acl->pass == NULL)
       acl->active = 0;			/* it can have a 'continue' so do not make it inactive */
#endif
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: acl %s %s is %sactive", acl->name, 
		       acl->within==UFDB_ACL_ELSE ? "ELSE" :
			  acl->within==UFDB_ACL_WITHIN ? "WITHIN" :
			     acl->within==UFDB_ACL_OUTSIDE ? "OUTSIDE" : "",
		       acl->active?"":"not " );
  }

  for (cat = Cat;  cat != NULL;  cat = cat->next)
  {
    if (cat->time != NULL) 
    {
      cat->active = cat->time->active;
      if (cat->within == UFDB_ACL_OUTSIDE)
	cat->active = !cat->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: category %s is %sactive", cat->name, cat->active?"":"not " );
  }

  for (s = UFDBgetSourceList();  s != NULL;  s = s->next)
  {
    if (s->time != NULL) 
    {
      s->active = s->time->active;
      if (s->within == UFDB_ACL_OUTSIDE)
	s->active = !s->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: source %s is %sactive", s->name, s->active?"":"not " );
  }

  for (rew = Rewrite; rew != NULL; rew = rew->next)
  {
    if (rew->time != NULL) 
    {
      rew->active = rew->time->active;
      if (rew->within == UFDB_ACL_OUTSIDE)
	 rew->active = !rew->active;
    }
    if (UFDBglobalDebug)
       ufdbLogMessage( "      _TimeSetAclSrcDestRew: rewite %s is %sactive", rew->name, rew->active?"":"not " );
  }
}


/*
 *  ufdbHandleAlarmForTimeEvents - the alarm for the next time event went off so 
 *                                 recalculate the time-dependent active state.
 */
void ufdbHandleAlarmForTimeEvents( 
   int        why )
{
   time_t     now;
   struct tm  tm_now;
   int        m;
   int        tindex;
   int        lastval;

   if (UFDBglobalDebug)
      ufdbLogMessage( "ufdbHandleAlarmForTimeEvents" );

   if (why == UFDB_PARAM_INIT)
      ufdbLogMessage( "time definitions are used; evaluating current ACLs" );
   else
   {
      ufdbLogMessage( "alarm went off to recalculate time ACLs" );
      if (UFDBglobalTerminating)
      {
	 ufdbLogMessage( "This alarm is ignored because ufdbguardd is exiting" );
	 return;
      }
      if (UFDBglobalReconfig)
      {
	 ufdbLogMessage( "This alarm is ignored because the configuration is being reloaded"
	                 " and a new alarm is set to go off in 15 seconds" );
	 alarm( 15 );
	 return;
      }
   }

   if (TimeList == NULL)
   {
      return;
   }

   getSortedTimeElementTimes();

   now = time(NULL) + 30 + globalDebugTimeDelta;
   localtime_r( &now, &tm_now ); 
   m = (tm_now.tm_hour * 60) + tm_now.tm_min;
  
   lastval = 0;
   for (tindex = 0;  tindex < numTimeElements;  tindex++)
   {
#if UFDB_TIME_DEBUG
      if (UFDBglobalDebug)
         ufdbLogMessage( "   TimeElementsEvents[%d] = %d", tindex, TimeElementsEvents[tindex] );
#endif
      lastval = TimeElementsEvents[tindex];
      if (TimeElementsEvents[tindex] >= m)
         break;
   }

   if (UFDBglobalDebug)
      ufdbLogMessage( "   ufdbHandleAlarmForTimeEvents: m = %d  tindex = %d, lastval = %d", m, tindex, lastval );

   if (lastval < m)
      m = (((1440 - m) + TimeElementsEvents[0]) * 60) - tm_now.tm_sec;
   else
      m = ((lastval - m) * 60) - tm_now.tm_sec;

   if (m <= 0)
      m = 30;

   _TimeEvaluateElements( &tm_now, now );
   _TimeSetAclSrcDestRew();

   ufdbFree( (void*) TimeElementsEvents );
   TimeElementsEvents = NULL;

   ufdbLogMessage( "next alarm is in %d seconds", (unsigned int) m );
   ufdbSetSignalHandler( SIGALRM, sgAlarm );
   (void) alarm( (unsigned int) m );
}


/*
 * sgTimeElementClone - copy a time specification.
 */
void sgTimeElementClone( void )
{
  struct TimeElement * te;
  struct TimeElement * tmp;

  te = lastTimeElement;
  if (te == NULL) 
  {
    ufdbLogFatalError( "No previous TimeElement in sgTimeElementClone !" );
    return;
  }
  else
  {
    sgTimeElementInit();
    lastTimeElement->wday = te->wday;
    lastTimeElement->from = te->from;
    lastTimeElement->to = te->to;
    lastTimeElement->y = te->y;
    lastTimeElement->m = te->m;
    lastTimeElement->d = te->d;
    lastTimeElement->fromdate = te->fromdate;
    lastTimeElement->todate = te->todate;
    tmp = lastTimeElement;
    lastTimeElement = te;
    sgTimeElementEnd();
    lastTimeElement = tmp;
  }
}


/*
 * IP functions
 */

void sgIpv4( 
   const char *   addr,
   int            type,
   char *         file,
   int            lineno )
{
   struct Ipv4 *  ipv4;
   char *         addr2;
   char *         cidr;
   char *         end;
   unsigned int   octet;

#if 1
   if (UFDBglobalDebug)
      ufdbLogMessage( "   sgIpv4( %s %d %s %d )", addr, type, file, lineno );
#endif

   switch (type)
   {
   case SG_IPTYPE_HOST:
	 if (lastSource->ipv4hosts == NULL)
	    lastSource->ipv4hosts = UFDBmemDBinit();
	 UFDBmemDBinsert( lastSource->ipv4hosts, addr, NULL );
  	 break;

   case SG_IPTYPE_RANGE:
	 addr2 = strchr( addr, '-' );
	 *addr2 = '\0';
	 end = addr2;
	 while (*(end-1) == ' '  ||  *(end-1) == '\t')
	 {
	    *(end-1) = '\0';
	    end--;
	 }
	 addr2++;
	 while (*addr2 == ' ' || *addr2 == '\t')
	    addr2++;

         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_RANGE;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (lastSource->ipv4 == NULL) 
	    lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s - %s", file, lineno, addr, addr2 );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (sgConvDot(addr2,&ipv4->mask) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s - %s", file, lineno, addr, addr2 );
	    ipv4->mask = 0;
	    ipv4->net_is_set = 0;
	 }

	 if ((unsigned int) ipv4->net > (unsigned int) ipv4->mask)
	     ufdbLogFatalError( "IPv4 range error in %s line %d: %s - %s", file, lineno, addr, addr2 );
  	 break;

   case SG_IPTYPE_CLASS:
	 addr2 = strchr( addr, '/' );
	 *addr2 = '\0';
	 addr2++;
         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_CLASS;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (lastSource->ipv4 == NULL) 
	    lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, addr2 );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (sgConvDot(addr2,&ipv4->mask) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, addr2 );
	    ipv4->mask = 0;
	 }
  	 break;

   case SG_IPTYPE_CIDR:
	 cidr = strchr( addr, '/' );
	 *cidr = '\0';
	 cidr++;
	 octet = (unsigned long) atoi( cidr );
	 if (octet > 32) 
	 {
	    ufdbLogFatalError( "IPv4 address CIDR out of range in %s line %d: %s/%s",
	                       file, lineno, addr, cidr );
	    octet = 32;
	 }
         ipv4 = (struct Ipv4 *) ufdbMalloc( sizeof(struct Ipv4) );
	 ipv4->type = SG_IPTYPE_CIDR;
         ipv4->net_is_set = 1;
	 ipv4->next = NULL;
	 if (lastSource->ipv4 == NULL) 
	    lastSource->ipv4 = ipv4;
	 else
	    sgIpv4Last( lastSource )->next = ipv4;

	 if (sgConvDot(addr,&ipv4->net) == NULL)
	 {
	    ufdbLogFatalError( "IPv4 address error in %s line %d: %s/%s", file, lineno, addr, cidr );
	    ipv4->net = 0;
	    ipv4->net_is_set = 0;
	 }
	 if (octet == 32)
	    ipv4->mask = 0xffffffff;
	 else
	    ipv4->mask = 0xffffffff ^ (0xffffffff >> octet);
	 ipv4->net = ipv4->net & ipv4->mask;
  	 break;
   }
}


struct Ipv4 * sgIpv4Last( 
   struct Source * s )
{
   struct Ipv4 * ipv4;
   struct Ipv4 * last;

   last = NULL;
   for (ipv4 = s->ipv4;  ipv4 != NULL;  ipv4 = ipv4->next)
      last = ipv4;

   return last;
}


struct Ipv6 * sgIpv6Last( 
   struct Source * s )
{
   struct Ipv6 * ipv6;
   struct Ipv6 * last;

   last = NULL;
   for (ipv6 = s->ipv6;  ipv6 != NULL;  ipv6 = ipv6->next)
      last = ipv6;

   return last;
}



void sgIpv6( 
   const char * addr,
   int          type,
   char *       file,
   int          line  )
{
#if 1
   if (UFDBglobalDebug)
      ufdbLogMessage( "   sgIpv6( %s %d  %s %d)", addr, type, file, lineno );
#endif

   if (type == SG_IPV6TYPE_HOST)
   {
      struct in6_addr dummy;
      if (!sgValidateIPv6( addr, &dummy ))
      {
         ufdbLogFatalError( "incorrect IPv6 address \"%s\" in %s line %d", addr, file, lineno );
      }
      else
      {
         if (lastSource->ipv6hosts == NULL)
	    lastSource->ipv6hosts = UFDBmemDBinit();
	 UFDBmemDBinsert( lastSource->ipv6hosts, addr, NULL );
      }
   }
   else if (type == SG_IPV6TYPE_CIDR)
   {
      char * s = (char*) strchr( addr, '/' );
      if (s == NULL)
      {
         ufdbLogFatalError( "IPv6 net has no '/' in \"%s\" in %s line %d", addr, file, lineno );
      }
      else
      {
	 struct Ipv6 *  ipv6;

	 ipv6 = (struct Ipv6 *) ufdbMalloc( sizeof(struct Ipv6) );
	 ipv6->type = SG_IPV6TYPE_CIDR;
	 ipv6->next = NULL;
	 if (lastSource->ipv6 == NULL) 
	    lastSource->ipv6 = ipv6;
	 else
	    sgIpv6Last( lastSource )->next = ipv6;

         *s = '\0';
         ipv6->cidr = (unsigned long) atoi( s+1 );
         if (ipv6->cidr > 128) 
         {
            ufdbLogFatalError( "IPv6 address CIDR out of range \"%s\" in %s line %d", addr, file, lineno );
            ipv6->cidr = 128;
         }
         if (!sgValidateIPv6( addr, &ipv6->ipv6 ))
         {
            ufdbLogFatalError( "incorrect IPv6 address \"%s\" in %s line %d", addr, file, lineno );
         }
         *s = '/';
      }
   }
   else
   {
      ufdbLogFatalError( "sgIpv6 called with unsupported type %d in %s line %d: %s", type, file, lineno, addr );
   }
}


/*
 * ACL functions
 */

void sgAcl( 
   const char *    name,
   const char *    value, 
   int             within )
{
   struct Acl *    acl;
   struct Source * source;

#if UFDB_DEBUG
   ufdbLogMessage( "sgAcl name=\"%s\" value=\"%s\" within=%d line=%d", 
                   name==NULL?"NULL":name,  value==NULL?"NULL":value, within, lineno );
#endif

   if (AclList != NULL) 
   {
      if (sgAclFindName(name) != NULL)
      {
	 ufdbLogFatalError( "line %d: ACL \"%s\" is already defined in configuration file %s",
			    lineno, name, UFDBglobalConfigFile );
      }
   }

  if (within == UFDB_ACL_ELSE)
  {
     if (lastAcl == NULL)
     {
        ufdbLogFatalError( "line %d: ACL \"else\" has no parent ACL", lineno );
        return;
     }
     if (name == NULL)
        name = ufdbStrdup( lastAcl->name );
  }

  acl = (struct Acl *) ufdbMalloc( sizeof(struct Acl) );

  source = NULL;
  if (strcmp(name,"default") == 0)
  {
    defaultAcl = acl;
  }
  else
  {
    if ((source = defSourceFindName(name)) == NULL)
    {
      ufdbLogFatalError( "line %d: ACL source \"%s\" is not defined in configuration file %s",
		         lineno, name, UFDBglobalConfigFile );
      ufdbFree( (void*) name );
      return;
    }
  }

  acl->name = name;
  acl->active = within == UFDB_ACL_ELSE ? 0 : 1;
  acl->source = source;
  acl->pass = NULL;
  acl->implicitPass = NULL;
  acl->hasTerminatorNone = 0;
  acl->rewriteDefault = 1;
  acl->rewrite = NULL;
  acl->redirect = NULL;
  acl->time = NULL;
  acl->within = within;
  acl->next = NULL;

  if (value != NULL) 
  {
    struct ufdbTime * t;
    if ((t = sgTimeFindName(value)) == NULL) 
    {
      ufdbLogFatalError( "line %d: ACL time %s is not defined in configuration file %s",
		         lineno, value, UFDBglobalConfigFile );
      return;
    }
    acl->time = t;
  }

  if (AclList == NULL) 
  {
    AclList = acl;
    lastAcl = acl;
  }
  else
  {
    lastAcl->next = acl;
    lastAcl = acl;
  }
}


void sgAclSetValue( 
  const char *         what,
  const char *         value, 
  int                  allowed ) 
{
  struct Category *    cat = NULL;
  struct AclCategory * aclcat;
  int                  type;
  
#if UFDB_DEBUG
   ufdbLogMessage( "sgAclSetValue %s %s%s", what, allowed?"":"!", value );
#endif

  if (lastAcl == NULL)
  {
     ufdbLogError( "error in configuration file on line %d: cannot set value for \"%s\" because there is no defined ACL", 
                   lineno, what );
     ufdbFree( (void*) value );
     return;
  }

  type = ACL_TYPE_TERMINATOR;

  if (strcmp(what,"pass") == 0)
  {
    if (strcmp(value,"any")==0 || strcmp(value,"all")==0)
    {
       if (!allowed)
          ufdbLogFatalError( "error in configuration file on line %d: do not use '!any' or '!all'.  Use 'none' instead.", lineno );
       allowed = 1;
    }
    else if (strcmp(value,"none") == 0)
    {
       if (!allowed)
          ufdbLogFatalError( "error in configuration file on line %d: do not use '!none'.  Use 'any' instead.", lineno );
       allowed = 0;
    }
    else if (strcmp(value,"in-addr") == 0) {
      type = ACL_TYPE_INADDR;
    }
    else
    {
      if ((cat = ufdbCategoryFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "ACL category \"%s\" (line %d) is not defined in configuration file %s",
			   value, lineno, UFDBglobalConfigFile );
	ufdbFree( (void*) value );
        return;
      } 
      type = ACL_TYPE_DEFAULT;
    }

    aclcat = (struct AclCategory *) ufdbMallocAligned( 64, sizeof(struct AclCategory) );
    aclcat->name = value;
    aclcat->cat = cat;
    aclcat->access = allowed;
    aclcat->type = type;
    aclcat->next = NULL;
    aclcat->nblocks = 0;
    aclcat->nmatches = 0;

    if (lastAcl->pass == NULL) {
      lastAcl->pass = aclcat;
    } else {
      lastAclCategory->next = aclcat;
    }
    lastAclCategory = aclcat;
  }
  else if (strcmp(what,"redirect") == 0)
  {
    if (strcmp(value,"default") != 0)
    {
      lastAcl->redirect = value;
    }
    else 
    {
      lastAcl->redirect = NULL;
      ufdbFree( (void*) value );
    }
  }
  else if (strcmp(what,"rewrite") == 0)
  {
    if (strcmp(value,"none") == 0)
    {
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = NULL;
    }
    else
    {
      struct sgRewrite * rewrite;

      if ((rewrite = sgRewriteFindName(value)) == NULL) 
      {
	ufdbLogFatalError( "rewrite %s is not defined in configuration file %s",
			   value, UFDBglobalConfigFile );
      }
      lastAcl->rewriteDefault = 0;
      lastAcl->rewrite = rewrite;
    }
    ufdbFree( (void*) value );
  }
}


struct Acl * sgAclFindName( 
  const char * name )
{
  struct Acl * p;

  if (name == NULL)
     return NULL;

  for (p = AclList;  p != NULL;  p = p->next)
  {
    if (strcmp(name,p->name) == 0)
      return p;
  }

  return NULL;
}


void yyerror( const char * s )
{
   ufdbLogFatalError( "line %d: %s in configuration file %s", lineno, s, UFDBglobalConfigFile );
}


int yywrap()
{
  return 1;
}

